freeslot("SPR_EXTR", "SFX_MSHURT", "SFX_EXEBET", "SPR_MTLE", "MT_MS_CORPSE", "S_MS_CORPSE1", "S_MS_CORPSE2", "S_MS_CORPSE3")

mobjinfo[MT_MS_CORPSE] = {
	doomednum = 341,
	spawnstate = S_MS_CORPSE1,
	radius = 20*FRACUNIT,
	height = 40*FRACUNIT,
	flags = MF_BOUNCE
}

sfxinfo[sfx_mshurt].caption = "Metal damage"
sfxinfo[sfx_exebet].caption = "Beat-up"

states[S_MS_CORPSE1] = {SPR_MTLE, A|FF_ANIMATE, -1, nil, 1, 15, S_MS_CORPSE1}
states[S_MS_CORPSE2] = {SPR_MTLE, C, -1, nil, 0, 0, S_MS_CORPSE2}
states[S_MS_CORPSE3] = {SPR_MTLE, D, -1, nil, 0, 0, S_MS_CORPSE3}

states[S_ENERGYBALL1] = {
	sprite = SPR_ENRG,
	frame = A|FF_ANIMATE,
	tics = -1,
	var1 = 3,
	var2 = 3,
	nextstate = S_ENERGYBALL2
}

addHook("MobjThinker", function(metal)
	if (metal.valid)
		if (leveltime == 45)
			S_StartSound(metal, sfx_mshurt)
			P_InstaThrust(metal, metal.angle+ANGLE_45, 6*FRACUNIT)
			metal.momz = 8*FRACUNIT
			metal.state = S_MS_CORPSE2
			for player in players.iterate
				S_ChangeMusic("BCZ1S", true, player)
			end
		end
		if (metal.state == S_MS_CORPSE2)
			metal.rollangle = $ + ANGLE_22h
		else
			metal.rollangle = 0
		end
		if (leveltime >= 50)
			if P_IsObjectOnGround(metal)
			or (metal.eflags & MFE_JUSTHITFLOOR)
				metal.state = S_MS_CORPSE3
			end
		end
	end
end, MT_MS_CORPSE)

mobjinfo[MT_METALSONIC_BATTLE].painsound = sfx_exebet

addHook("PlayerThink", function(player)
	if (player.spectator) return end
	if (mapheaderinfo[gamemap].race)
	and (players[0] == player)
	and (players[0].mo.valid)
	and (player.mo.skin == "exetior")
		if (leveltime == 0)
			player.powers[pw_nocontrol] = 70
		end
		if (leveltime >= 0) and (leveltime <= 70)
			player.drawangle = player.mo.angle
			if (leveltime >= 35) and (leveltime <= 55)
				player.mo.state = S_EXEPUSHED
			end
		end
		if (leveltime == 35)
		and (player.mo.skin == "exetior")
			P_InstaThrust(player.mo, player.mo.angle, -20*FRACUNIT)
			P_TeleportMove(player.mo, player.mo.x, player.mo.y, player.mo.z+2*FRACUNIT)
			player.skidtime = 35
		end
	elseif (mapheaderinfo[gamemap].race)
	and (players[0] == player)
	and (player.mo.skin ~= "exetior")
		if (leveltime == 0)
			player.powers[pw_nocontrol] = 70
			P_TeleportMove(player.mo, player.mo.x+P_ReturnThrustX(player.mo, player.mo.angle, -20*FRACUNIT), player.mo.y+P_ReturnThrustY(player.mo, player.mo.angle, -20*FRACUNIT), player.mo.z)
		end
	end
end)

addHook("MobjThinker", function(mobj)
	if not (mapheaderinfo[gamemap].race) return end
	mobj.skin = "sonic"
	if (players[0].mo.skin ~= "exetior")
		mobj.colorized = true
		mobj.color = SKINCOLOR_BLACK
	else
		mobj.colorized = false
		mobj.color = SKINCOLOR_BLUE
	end
	if (leveltime <= 35)
		mobj.flags2 = $1|MF2_DONTDRAW
	else
		if (leveltime == 35)
			local ghost = P_SpawnGhostMobj(mobj)
			ghost.colorized = true
			ghost.color = SKINCOLOR_BLACK
		end
		mobj.flags2 = $1 & ~MF2_DONTDRAW
	end
end, MT_METALSONIC_RACE)

addHook("MobjThinker", function(jetfume)
	if not jetfume.target return end
	if (jetfume.valid) and (jetfume.target.flags & MF_BOSS)
		jetfume.flags2 = $1|MF2_DONTDRAW
	end
end, MT_JETFUME1)

addHook("MobjDamage", function(metal)
	if (metal.hurt == 1) return end
	metal.hurt = 1
	A_Create_Liquid(metal, 1, 6, SKINCOLOR_RED, 4)
	A_Create_Liquid(metal, 1, 10, SKINCOLOR_RED, 10)
	metal.fuse = 1
end, MT_METALSONIC_BATTLE)

addHook("MobjThinker", function(metal)
	metal.hurt = $ or 0
	if (players[0].mo.skin ~= "exetior")
		metal.colorized = true
		metal.color = SKINCOLOR_BLACK
	else
		metal.colorized = false
	end
	if (metal.state ~= S_METALSONIC_PAIN)
		metal.hurt = 0
	end
	if (leveltime == 0)
		metal.oldx = metal.x
		metal.oldy = metal.y
		metal.oldz = metal.z
		S_StartSound(metal, sfx_supert)
	end
	if (leveltime <= 12)
		metal.sprite = SPR_EXTR
		metal.frame = leveltime
	elseif (leveltime > 12) and (leveltime <= 35)
		metal.sprite = SPR_EXTR
		metal.frame = L
	elseif (leveltime == 36)
		metal.frame = SPR_METL
		metal.frame = E
		metal.state = S_METALSONIC_FLOAT
	end
	if (leveltime <= 35)
		metal.momx = 0
		metal.momy = 0
		metal.momz = 0
		P_TeleportMove(metal, metal.oldx, metal.oldy, metal.oldz)
	end
end, MT_METALSONIC_BATTLE)

addHook("MobjThinker", function(metal)
	if metal.state == S_METALSONIC_PAIN
		metal.inpain = true
	elseif metal.state == S_METALSONIC_FLOAT and metal.inpain == true
		metal.inpain = false
		metal.fuse = 0
	end
end, MT_METALSONIC_BATTLE)

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid)
		player.ground = $ or 0
		if (leveltime == 0)
			player.ground = 0
		end
		if (player.ground ~= 0)
			player.ground = $ + 1
		end
	end
end)

//brak
//Brak MKII's model by Ordomandalor (prerendered by Man553), Missiles from ERZ's scrapped boss by FuriousFox

freeslot("MT_FINALBOSS","S_FINALBOSS_CHASE","MT_EGGMOBILE7_MISSILE","MT_FINALBOSS_DEAD")

addHook("MobjSpawn", function(mobj)
	mobj.scale = mobj.scale-mobj.scale/8
end, MT_FINALBOSS)

addHook("MobjSpawn", function(mobj)
	if (mapheaderinfo[gamemap].finalboss)
		mobj.scale = $1 * 4
		mobj.flags2 = $1|MF2_RAILRING
	end
end, MT_EGGMOBILE7_MISSILE)

addHook("BossThinker", function(mobj)
	S_SetMusicPosition(S_GetMusicPosition()+20)
	P_StartQuake(2*FRACUNIT, 1)
	if (mobj.state == S_FINALBOSS_CHASE)
		P_InstaThrust(mobj, mobj.angle, 4*FRACUNIT)
	end
	if (mobj.state == S_FINALBOSS_DEAD)
		mobj.angle = $ + ANG20
	end
end, MT_FINALBOSS)

freeslot("S_EGG_RAGE")

states[S_EGG_RAGE] = {
	sprite = SPR_BRAK,
	frame = V,
	nextstate = S_EGG_RAGE,
	tics = -1
}

addHook("MobjThinker", function(brak)
	brak.phasetwo = $ or 0
	if (brak.health == 3)
		brak.state = S_EGG_RAGE
		brak.phasetwo = $ + 1
	end
	if (brak.phasetwo ~= 0)
		if (brak.phasetwo == 1)
			for player in players.iterate
				S_ChangeMusic("fnlbos", true, player, 0, 0, 2*MUSICRATE, MUSICRATE)
			end
			S_StartSound(brak, sfx_s3k53)
		end
		if (brak.phasetwo >= 3*TICRATE)
			S_StartSound(brak, sfx_s3k54)
			for p in players.iterate
				for sector in sectors.iterate do
					sector.lightlevel = $ - 48
				end
				S_StartSound(nil, sfx_itemup, p)
				local explosion = P_SpawnMobj(brak.x, brak.y, brak.z, MT_EXPLODE)
				explosion.scale = 3*FRACUNIT
				explosion.state = S_TNTBARREL_EXPL1
				P_SpawnMobj(brak.x, brak.y, brak.z, MT_FINALBOSS)
				brak.state = S_NULL
				p.ground = 1
				p.rings = $ + 20
			end
		end
	end
end, MT_CYBRAKDEMON)

local function drawBrakFade(v, p, c)
	if not (p.mo) return end
	if (p.mo.valid)
		local flags
		if not (p.ground) return end
		if (p.ground > 100) return end
		if (p.ground < 10)
			flags = V_SNAPTOLEFT
		elseif (p.ground >= 10)
		and (p.ground <= 20)
			flags = V_10TRANS
		elseif (p.ground >= 20)
		and (p.ground <= 30)
			flags = V_20TRANS
		elseif (p.ground >= 30)
		and (p.ground <= 40)
			flags = V_30TRANS
		elseif (p.ground >= 40)
		and (p.ground <= 50)
			flags = V_40TRANS
		elseif (p.ground >= 50)
		and (p.ground <= 60)
			flags = V_50TRANS
		elseif (p.ground >= 60)
		and (p.ground <= 70)
			flags = V_60TRANS
		elseif (p.ground >= 70)
		and (p.ground <= 80)
			flags = V_70TRANS
		elseif (p.ground >= 80)
		and (p.ground <= 90)
			flags = V_80TRANS
		elseif (p.ground >= 90)
		and (p.ground <= 100)
			flags = V_90TRANS
		end
		v.draw(-1,-1,v.cachePatch("BLACK"),flags)
	end
end

hud.add(drawBrakFade, "game")