local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
	BattleFuncSet = true
	
	local ArrowShoot = function(mo,doaction,pressedaction)
		local player = mo.player
		player.actiontext = "Arrowshoot"
		player.actionrings = 2
		//Ability start
		if player.actionstate == 0 and doaction == 1 then
			player.actionstate = 1
			player.actiontime = 0
			CBW_Battle.PayRings(player)
		end	
		
		if player.actionstate == 1
			CBW_Battle.ApplyCooldown(player,TICRATE)
			player.actiontime = 0
			player.drawangle = player.mo.angle
			player.actionstate = 0
			local an = player.mo.angle
			local slope = player.aiming
			S_StartSound(player.mo, sfx_shot)
			local th = P_SpawnMobj(player.mo.x + (1*cos(an)), player.mo.y + (1*sin(an)), player.mo.z+6*FRACUNIT, MT_SHOOTSPIKE)
			//Missile copies player's scale
			th.scale = player.mo.scale
			// missiles can't hurt their targets, note
			th.target = player.mo
			//Determine speed
			local speed = 70*FRACUNIT
			if player.mo.eflags & MFE_VERTICALFLIP then
				th.flags2 = $1|MF2_OBJECTFLIP // flip gravity!
				th.z = $1 - th.height - player.mo.height/3
			end
			th.angle = an
			th.momx = FixedMul(speed, cos(an))
			th.momy = FixedMul(speed, sin(an))
			th.momx = FixedMul(th.momx, cos(slope))
			th.momy = FixedMul(th.momy, cos(slope))
			th.momz = FixedMul(speed, sin(slope))	
		end
	end
	
	CBW_Battle.SkinVars["exetior"] = {
 		weight = 120,
 		shields = 4,
		special = CBW_Battle.Action.EnergyAttack,
 		guard_enabled = true,
 		guard_frame = 3,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry,
 		func_priority = CBW_Battle.Priority_FullCommon
	}

	CBW_Battle.SkinVars["why"] = {
 		weight = 80,
 		shields = 1,
		special = ArrowShoot,
 		guard_enabled = true,
 		guard_frame = 8,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry,
 		func_priority = CBW_Battle.Priority_FullCommon
	}
end)