/* GIB COOLDOWN COMMAND */

local gibs_gibcooldown = 5

local function gibs_gibcooldown_function(player, argl)
	if tonumber(argl)
		gibs_gibcooldown = tonumber(argl)	
	else
		CONS_Printf(player,"Gib cooldown determines how long it takes for gibs to disappear.")
	end
	CONS_Printf(player,"Gib cooldown is currently " + gibs_gibcooldown + " seconds.")
end

COM_AddCommand("gibs_gibcooldown",gibs_gibcooldown_function,1)

/* GIBS */
freeslot(
"SPR_BOLT",
"SPR_NUTT",
"SPR_BONE",
"SPR_SKLL",
"SPR_MONT",
"SPR_CORE",
"MT_GIBS",
"S_GIB_BOLT",
"S_GIB_NUTT",
"S_GIB_BONE",
"S_GIB_SKULL",
"S_GIB_MONT",
"S_GIB_CORE"
)

mobjinfo[MT_GIBS] = {
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	speed = 2*FRACUNIT,
	spawnstate = S_GIB_BOLT,
	flags = MF_BOUNCE|MF_SCENERY|MF_SPECIAL
}
states[S_GIB_BOLT] = {
	sprite = SPR_BOLT,
	frame = A,
	tics = -1,
}
states[S_GIB_NUTT] = {
	sprite = SPR_NUTT,
	frame = A,
	tics = -1,
}
states[S_GIB_BONE] = {
	sprite = SPR_BONE,
	frame = A,
	tics = -1,
}
states[S_GIB_SKULL] = {
	sprite = SPR_SKLL,
	frame = A,
	tics = -1,
}
states[S_GIB_MONT] = {
	sprite = SPR_MONT,
	frame = A,
	tics = -1,
}
states[S_GIB_CORE] = {
	sprite = SPR_CORE,
	frame = A,
	tics = -1,
}

local cv_enablegibs = CV_RegisterVar({"exe_gibs", "On", CV_NETVAR, CV_OnOff})

local function gibs_handler(mo)
	if not mo.timeout
		mo.timeout = gibs_gibcooldown*TICRATE
	else
		mo.timeout = mo.timeout - 1
	end
	local new_frame
	if abs(mo.momx) > 0 and abs(mo.momy) > 0
		if abs(mo.momx) > abs(mo.momy)
			A_RollAngle(mo,(abs(mo.momx)/10))
		else
			A_RollAngle(mo,(abs(mo.momy)/10))
		end
	end
	if P_IsObjectOnGround(mo)
		P_SetObjectMomZ(mo,-(FixedInt(mo.prev_momz)/2)*FRACUNIT,false)
		if mo.momz < FRACUNIT
			mo.momz = 0
		end
	end
	if abs(mo.momx) > FRACUNIT and abs(mo.momy) > FRACUNIT and abs(mo.momz) > 0
		local trail = P_SpawnMobj(mo.x,mo.y,mo.z,MT_TRAIL)
		trail.color = mo.color
	end
	mo.prev_momz = mo.momz
	if mo.timeout == 0
		P_RemoveMobj(mo)
	end
end

local function gibs_kicker(mo,player)
	if player.momx > player.momy
		P_InstaThrust(mo,player.angle,player.momx)
		P_SetObjectMomZ(mo,player.momx,false)
	else
		P_InstaThrust(mo,player.angle,player.momy)
		P_SetObjectMomZ(mo,player.momy,false)
	end
	return true
end

addHook("MobjThinker", gibs_handler, MT_GIBS)

addHook("TouchSpecial", gibs_kicker, MT_GIBS)

/* LIQUID COOLDOWN COMMAND */

local gibs_liqcooldown = 1

local function gibs_liqcooldown_function(player, argl)
	if tonumber(argl)
		gibs_liqcooldown = tonumber(argl)	
	else
		CONS_Printf(player,"This determines how long it takes for liquids to disappear.")
	end
	CONS_Printf(player,"This cooldown is currently " + gibs_liqcooldown + " seconds.")
end

COM_AddCommand("gibs_liqcooldown",gibs_liqcooldown_function,1)

/* LIQUID */
freeslot(
"SPR_LIQD",
"MT_LIQUID",
"S_LIQD_BIG",
"S_LIQD_SMALL",
"S_LIQD_TINY",
"S_LIQD_BIG_SPLAT",
"S_LIQD_SMALL_SPLAT",
"S_LIQD_TINY_SPLAT"
)

mobjinfo[MT_LIQUID] = {
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	spawnstate = S_LIQD_BIG,
	flags = MF_BOUNCE|MF_SCENERY
}

states[S_LIQD_BIG] = {
	sprite = SPR_LIQD,
	frame = A|TR_TRANS40,
	tics = 10,
	nextstate = S_LIQD_BIG
}

states[S_LIQD_SMALL] = {
	sprite = SPR_LIQD,
	frame = B|TR_TRANS40,
	tics = 10,
	nextstate = S_LIQD_SMALL
}

states[S_LIQD_TINY] = {
	sprite = SPR_LIQD,
	frame = C|TR_TRANS40,
	tics = 10,
	nextstate = S_LIQD_TINY
}

states[S_LIQD_BIG_SPLAT] = {
	sprite = SPR_LIQD,
	frame = D|TR_TRANS40,
	tics = 10,
	nextstate = S_LIQD_BIG_SPLAT
}

states[S_LIQD_SMALL_SPLAT] = {
	sprite = SPR_LIQD,
	frame = E|TR_TRANS40,
	tics = 10,
	nextstate = S_LIQD_SMALL_SPLAT
}

states[S_LIQD_TINY_SPLAT] = {
	sprite = SPR_LIQD,
	frame = F|TR_TRANS40,
	tics = 10,
	nextstate = S_LIQD_TINY_SPLAT
}

local function liquid_handler(mo)
	if not mo.timeout
		mo.timeout = gibs_liqcooldown*TICRATE
	else
		mo.timeout = mo.timeout - 1
	end
	if P_IsObjectOnGround(mo)
		if mo.state == S_LIQD_BIG
			A_Create_Liquid(mo, 2, 3, mo.color, 2)
			mo.state = S_LIQD_BIG_SPLAT
			mo.momz = 0
		elseif mo.state == S_LIQD_SMALL
			if P_RandomRange(0, 100) > 50
				A_Create_Liquid(mo, 3, 5, mo.color, 1)
			end
			mo.state = S_LIQD_SMALL_SPLAT
			mo.momz = 0
		elseif mo.state == S_LIQD_TINY
			mo.state = S_LIQD_TINY_SPLAT
			mo.momz = 0
		end
	end
	if mo.timeout == 0
		P_RemoveMobj(mo)
	end
end

addHook("MobjThinker", liquid_handler, MT_LIQUID)

/* TRAILS THAT FOLLOW GIBS, BECAUSE IT CAN'T GET LAGGY ENOUGH (TM) */

freeslot(
"SPR_TRIL",
"MT_TRAIL",
"S_TRAIL"
)

mobjinfo[MT_TRAIL] = {
	spawnstate = S_TRAIL,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_NOGRAVITY|MF_SCENERY
}
states[S_TRAIL] = {
	sprite = SPR_TRIL,
	frame = A|TR_TRANS70,
	tics = TICRATE,
	nextstate = S_TRAIL,
}

local function trail_handler(mo)
	if mo.destscale == FRACUNIT
		mo.destscale = 1
		mo.scalespeed = FRACUNIT/24
	end
	if mo.scale < FRACUNIT/5
		P_RemoveMobj(mo)
	end
end

addHook("MobjThinker", trail_handler, MT_TRAIL)

/* GIBS MOD FOR 2.2 */
/* Made by TrustyGun */

//Sounds

rawset(_G, "gibs", {})
//Lists
gibs.organic = {
	MT_METALSONIC_BATTLE,
	MT_GOOMBA,
	MT_BLUEGOOMBA,
	MT_REDCRAWLA,
	MT_GFZFISH,
	MT_GOLDBUZZ,
	MT_REDBUZZ,
	MT_JETTBOMBER,
	MT_JETTGUNNER,
	MT_CRAWLACOMMANDER,
	MT_DETON,
	MT_SKIM,
	MT_TURRET,
	MT_POPUPTURRET,
	MT_SPINCUSHION,
	MT_CRUSHSTACEAN,
	MT_BANPYURA,
	MT_BANPSPRING,
	MT_JETJAW,
	MT_SNAILER,
	MT_VULTURE,
	MT_POINTY,
	MT_ROBOHOOD,
	MT_FACESTABBER,
	MT_EGGGUARD,
	MT_GSNAPPER,
	MT_MINUS,
	MT_SPRINGSHELL,
	MT_YELLOWSHELL,
	MT_UNIDUS,
	MT_CANARIVORE,
	MT_PYREFLY,
	MT_PTERABYTE,
	MT_DRAGONBOMBER,
	MT_PENGUINATOR,
	MT_POPHAT,
	MT_HIVEELEMENTAL,
	MT_BUMBLEBORE,
	MT_SPINBOBERT,
	MT_HANGSTER
}

gibs.mechanical = {	//enemies and mechanical objects

}

gibs.monitor = {	//monitors
	MT_RING_BOX,
	MT_PITY_BOX,
	MT_ATTRACT_BOX,
	MT_FORCE_BOX,
	MT_ARMAGEDDON_BOX,
	MT_WHIRLWIND_BOX,
	MT_ELEMENTAL_BOX,
	MT_SNEAKERS_BOX,
	MT_INVULN_BOX,
	MT_1UP_BOX,
	MT_EGGMAN_BOX,
	MT_MIXUP_BOX,
	MT_MYSTERY_BOX,
	MT_GRAVITY_BOX,
	MT_RECYCLER_BOX,
	MT_SCORE1K_BOX,
	MT_SCORE10K_BOX,
	MT_FLAMEAURA_BOX,
	MT_BUBBLEWRAP_BOX,
	MT_THUNDERCOIN_BOX,
	MT_PITY_GOLDBOX,
	MT_ATTRACT_GOLDBOX,
	MT_FORCE_GOLDBOX,
	MT_ARMAGEDDON_GOLDBOX,
	MT_WHIRLWIND_GOLDBOX,
	MT_ELEMENTAL_GOLDBOX,
	MT_SNEAKERS_GOLDBOX,
	MT_INVULN_GOLDBOX,
	MT_EGGMAN_GOLDBOX,
	MT_GRAVITY_GOLDBOX,
	MT_FLAMEAURA_GOLDBOX,
	MT_BUBBLEWRAP_GOLDBOX,
	MT_THUNDERCOIN_GOLDBOX,
	MT_RING_REDBOX,
	MT_RING_BLUEBOX
}

gibs.boss = {		//bosses (spits out oil, if you have an organic boss try the organical table instead)
	MT_EGGMOBILE,
	MT_EGGMOBILE2,
	MT_EGGMOBILE3,
	MT_EGGMOBILE4,
	MT_BLACKEGGMAN,
	MT_CYBRAKDEMON
}

gibs.etheral = {
	MT_SPINBOBERT
}
//these following ones are for players
gibs.skin_male = {
	"sonic",
	"tails",
	"knuckles",
	"fang"
	
}

gibs.skin_female = {
	"amy"
	
}

gibs.skin_mechanical = {
	"metalsonic"
}

gibs.skin_pref_color = {
	} //this will use a skin's skin color for the blood.
	
local function Gibs_CheckIfInList(mo)
	local return_value = 0
	for _,v in ipairs(gibs.organic)
		if v == mo
			return return_value
		end
	end
	local return_value = 1
	for _,v in ipairs(gibs.mechanical)
		if v == mo
			return return_value
		end
	end
	local return_value = 2
	for _,v in ipairs(gibs.monitor)
		if v == mo
			return return_value
		end
	end
	local return_value = 3
	for _,v in ipairs(gibs.boss)
		if v == mo
			return return_value
		end
	end
	local return_value = 4
	for _,v in ipairs(gibs.etheral)
		if v == mo
			return return_value
		end
	end
end

local function Skins_CheckIfInList(mo)
	local return_value = 0
	for _,v in ipairs(gibs.skin_male)
		if v == mo
			return return_value
		end
	end
	local return_value = 1
	for _,v in ipairs(gibs.skin_female)
		if v == mo
			return return_value
		end
	end
	local return_value = 2
	for _,v in ipairs(gibs.skin_mechanical)
		if v == mo
			return return_value
		end
	end
	local return_value = 3
	for _,v in ipairs(gibs.skin_pref_color)
		if v == mo
			return return_value
		end
	end
	return 4
end

/* We overwrite the player's deathstate so it looks like they explode into gore */
/*states[S_PLAY_DEAD] = {
	sprite = NULL,
	frame = A,
	tics = -1,
	nextstate = S_NULL,
}

states[S_PLAY_DRWN] = {
	sprite = NULL,
	frame = A,
	tics = -1,
	nextstate = S_NULL,
}
*/
/* Console Commands */

local gibs_organic = true

local function gibs_organic_function(player, argl)
	CONS_Printf(player,"This decides if organic blood and gibs spawn.  - 0 is off, 1 is on")
	if tonumber(argl) == 0
		gibs_organic = false
		CONS_Printf(player,"Organic Gibs off!")
	elseif tonumber(argl) == 1
		gibs_organic = true
		CONS_Printf(player,"Organic Gibs on!")
	end
end

COM_AddCommand("gibs_organic",gibs_organic_function,1)

local gibs_voice = true

local function gibs_voice_function(player, argl)
	CONS_Printf(player,"This turns off and on the player's death scream - 0 is off, 1 is on")
	CONS_Printf(player,"gibs_organic needs to be on for the death scream to play.")
	if tonumber(argl) == 0
		gibs_voice = false
		CONS_Printf(player,"Player Voice off!")
	elseif tonumber(argl) == 1
		gibs_voice = true
		CONS_Printf(player,"Player Voice on!")
	end
end

COM_AddCommand("gibs_voice",gibs_voice_function,1)

local function gibs_help_function(player)
	CONS_Printf(player,"Gib Mod Commands:")
	CONS_Printf(player,"	gibs_liqcooldown")
	CONS_Printf(player,"	gibs_gibcooldown")
	CONS_Printf(player,"	gibs_organic")
	CONS_Printf(player,"	gibs_voice")
	CONS_Printf(player,"Use the command to learn more about it")
end

COM_AddCommand("gibs_help",gibs_help_function,1)

/* FUNCTIONS */

function A_Create_Liquid(mo,liq_type,max_liqd,color,mom)
	if not (cv_enablegibs.value) return end
	for i = 0,max_liqd
		local angle = ((mo.angle-(FixedAngle(180)*FRACUNIT)-(FixedAngle(i * 45)*FRACUNIT)) + FixedAngle(90/(i+1))*FRACUNIT)
		local liq = P_SpawnMobj(mo.x,mo.y,mo.z+(1*FRACUNIT),MT_LIQUID)
		if liq_type == 1
			liq.state = S_LIQD_BIG
		elseif liq_type == 2
			liq.state = S_LIQD_SMALL
		else
			liq.state = S_LIQD_TINY
		end
		liq.color = color
		P_SetObjectMomZ(liq,P_RandomRange(1,mom)*FRACUNIT,false)
		P_InstaThrust(liq,angle,P_RandomRange(1,mom)*FRACUNIT)
	end
end


function A_Create_Gibs(mo,gib_type,max_gibs,mom,color)
	if not (cv_enablegibs.value) return end
	if max_gibs == 0
		local angle = FixedAngle(P_RandomRange(0,360)*FRACUNIT)
		local gib = P_SpawnMobj(mo.x,mo.y,mo.z+(1*FRACUNIT),MT_GIBS)
		if gib_type == 1
			gib.state = S_GIB_BOLT
		elseif gib_type == 2
			gib.state = S_GIB_NUTT
		elseif gib_type == 3
			gib.state = S_GIB_BONE
		elseif gib_type == 4
			gib.state = S_GIB_SKULL
		elseif gib_type == 5
			gib.state = S_GIB_MONT
		else
			gib.state = S_GIB_CORE
		end
		gib.color = color
		P_SetObjectMomZ(gib,P_RandomRange(1,mom*2)*FRACUNIT,false)
		P_InstaThrust(gib,angle,P_RandomRange(1,mom*2)*FRACUNIT)
		return gib
	else
		for i = 0,max_gibs
			local angle = ((mo.angle-(FixedAngle(180)*FRACUNIT)-(FixedAngle(i * 45)*FRACUNIT)) + FixedAngle(90/(i+1))*FRACUNIT)
			local gib = P_SpawnMobj(mo.x,mo.y,mo.z+(1*FRACUNIT),MT_GIBS)
			if gib_type == 1
				gib.state = S_GIB_BOLT
			elseif gib_type == 2
				gib.state = S_GIB_NUTT
			elseif gib_type == 3
				gib.state = S_GIB_BONE
			elseif gib_type == 4
				gib.state = S_GIB_SKULL
			elseif gib_type == 5
				gib.state = S_GIB_MONT
			else
				gib.state = S_GIB_CORE
			end
			gib.color = color
			P_SetObjectMomZ(gib,P_RandomRange(1,mom)*FRACUNIT,false)
			P_InstaThrust(gib,angle,P_RandomRange(1,mom)*FRACUNIT)
		end
	end
end

local function blood_handler(target)
	/* THESE ARE SPECIAL CASES */
	local debug_string = "Blood: "
	if target.type == MT_PLAYER and gibs_organic == true
		debug_string = debug_string + target.player.name
		local blood_color = 0
		local skin_type = Skins_CheckIfInList(target.skin)
		if gametype == GT_COOP or gametype == GT_COMPETITION or gametype == GT_RACE
			if skin_type == 0 or skin_type == 1
				blood_color = SKINCOLOR_RED
			elseif	skin_type == 2
				blood_color = SKINCOLOR_BLACK
			elseif 	skin_type == 3
				blood_color = target.color
			else
				blood_color = SKINCOLOR_RED
			end
		else
			blood_color = target.color
		end
		A_Create_Liquid(target, 1, 6, blood_color, 4)
		A_Create_Liquid(target, 2, 8, blood_color, 8)
		//print(debug_string)
		return
	elseif	target.type == MT_FANG
		debug_string = "Fang Boss"
		local blood_color = 0
		if not target.fang_real
			blood_color = SKINCOLOR_BLACK
		else
			blood_color = SKINCOLOR_RED
			if gibs_organic == false
				return
			end
		end
		A_Create_Liquid(target, 1, 6, blood_color, 4)
		A_Create_Liquid(target, 2, 8, blood_color, 8)
		//print(debug_string)
		return 
	end
	/* Now we move on to the normal cases */
	local gibs_list = Gibs_CheckIfInList(target.type)
	if gibs_list == 0 and organic_gibs == true//Organic
		A_Create_Liquid(target, 1, 6, SKINCOLOR_RED, 4)
		A_Create_Liquid(target, 2, 8, SKINCOLOR_RED, 8)
		A_Create_Liquid(target, 1, 10, SKINCOLOR_RED, 10)
		A_Create_Liquid(target, 2, 8, SKINCOLOR_RED, 12)
		A_Create_Liquid(target, 3, 6, SKINCOLOR_BLACK, 14)
		A_Create_Gibs(target,3,11,4, SKINCOLOR_BLACK)
		A_Create_Gibs(target,4,0,8, SKINCOLOR_RED)
		debug_string = debug_string + "Organic"
	elseif gibs_list == 1 //mechanical
		A_Create_Liquid(target, 1, 4, SKINCOLOR_BLACK, 4)
		A_Create_Liquid(target, 2, 6, SKINCOLOR_BLACK, 8)
		debug_string = debug_string + "Mechanical"
	elseif gibs_list == 3 //mechanical
		A_Create_Liquid(target, 1, 10, SKINCOLOR_BLACK, 6)
		A_Create_Liquid(target, 2, 8, SKINCOLOR_BLACK, 10)
		A_Create_Liquid(target, 3, 6, SKINCOLOR_BLACK, 12)
		A_Create_Gibs(target,1,6,32,SKINCOLOR_BLACK)
		A_Create_Gibs(target,2,6,32,SKINCOLOR_BLACK)
		debug_string = debug_string + "Boss"
	elseif gibs_list == 4 	//etheral
		A_Create_Liquid(target, 1, 4, SKINCOLOR_WHITE, 4)
		A_Create_Liquid(target, 2, 6, SKINCOLOR_WHITE, 8)
		debug_string = debug_string + "Etheral"
	else
		debug_string = debug_string + "Incompatiable"
	end
	//print(debug_string)
end
	
addHook("MobjDamage", blood_handler, MT_NULL)

local function gib_handler(target)
	local debug_string = "Gibs: "
	/* UNIQUE CASES */
	if target.type == MT_PLAYER and gibs_organic == true
		debug_string = debug_string + target.player.name
		local blood_color = 0
		local skin_type = Skins_CheckIfInList(target.skin)
		if gametype == GT_COOP or gametype == GT_COMPETITION or gametype == GT_RACE
			if skin_type == 0 or skin_type == 1
				blood_color = SKINCOLOR_RED
			elseif skin_type == 2
				blood_color = SKINCOLOR_BLACK
			elseif skin_type == 3
				blood_color = target.color
			else
				blood_color = SKINCOLOR_RED
			end
		else
			blood_color = target.color
		end
		A_Create_Liquid(target, 1, 10, blood_color, 10)
		A_Create_Liquid(target, 2, 8, blood_color, 12)
		A_Create_Liquid(target, 3, 6, blood_color, 14)
		if skin_type == 0 or skin_type == 1
			A_Create_Gibs(target,3,11,4,blood_color)
			target.skull = A_Create_Gibs(target,4,0,8,blood_color)
		elseif	skin_type == 2
			A_Create_Gibs(target,1,5,4,blood_color)
			A_Create_Gibs(target,2,6,4,blood_color)
			target.skull = A_Create_Gibs(target,6,0,8,blood_color)
		elseif skin_type == 3
			target.skull = A_Create_Gibs(target,4,0,8,blood_color)
		else
			A_Create_Gibs(target,3,11,4,SKINCOLOR_RED)
			target.skull = A_Create_Gibs(target,4,0,8,SKINCOLOR_RED)
		end
		target.scale = FRACUNIT/5
		debug_string = debug_string + target.player.name + " Player_Gibs is 0"
		return false
	elseif	target.type == MT_FANG
		debug_string = "Fang Boss"
		//this is only for the doppelganger version. the flesh-and-blood version has a much more amusing death. :)
		if not target.fang_real
			A_Create_Liquid(target, 1, 10, SKINCOLOR_BLACK, 6)
			A_Create_Liquid(target, 2, 8, SKINCOLOR_BLACK, 10)
			A_Create_Liquid(target, 3, 6, SKINCOLOR_BLACK, 12)
			A_Create_Gibs(target,1,6,32,SKINCOLOR_BLACK)
			A_Create_Gibs(target,2,6,32,SKINCOLOR_BLACK)
		end
		//print(debug_string)
		return
	elseif target.type == MT_METALSONIC_BATTLE
		target.metal_dead = 1
	end
	/* Normal Cases */
	local gibs_list = Gibs_CheckIfInList(target.type)
	if gibs_list == 0 and organic_gibs == true//Organic
		A_Create_Liquid(target, 1, 10, SKINCOLOR_RED, 10)
		A_Create_Liquid(target, 2, 8, SKINCOLOR_RED, 12)
		A_Create_Liquid(target, 3, 6,SKINCOLOR_RED, 14)
		A_Create_Gibs(target,3,11,16,SKINCOLOR_RED)
		A_Create_Gibs(target,4,0,4,SKINCOLOR_RED)
		debug_string = debug_string + "Organic"
	elseif gibs_list == 1 //mechanical
		A_Create_Gibs(target,1,4,16,SKINCOLOR_BLACK)
		A_Create_Gibs(target,2,4,16,SKINCOLOR_BLACK)
		debug_string = debug_string + "Enemy"
	elseif gibs_list == 2 //monitors
		A_Create_Gibs(target,5,7,6,SKINCOLOR_WHITE)
		A_Create_Liquid(target, 1, 1, SKINCOLOR_BLACK, 3)
		A_Create_Liquid(target, 3, 6, SKINCOLOR_BLACK, 12)
		debug_string = debug_string + "Monitor"
	elseif gibs_list == 3 //boss
		A_Create_Liquid(target, 1, 10, SKINCOLOR_BLACK, 10)
		A_Create_Liquid(target, 2, 8, SKINCOLOR_BLACK, 12)
		A_Create_Liquid(target, 3, 6, SKINCOLOR_BLACK, 16)
		A_Create_Gibs(target,1,6,32,SKINCOLOR_BLACK)
		A_Create_Gibs(target,2,6,32,SKINCOLOR_BLACK)
		debug_string = debug_string + "Boss"
	elseif gibs_list == 4 	//etheral
		A_Create_Liquid(target, 1, 10, SKINCOLOR_WHITE, 6)
		A_Create_Liquid(target, 2, 8, SKINCOLOR_WHITE, 10)
		A_Create_Liquid(target, 3, 6, SKINCOLOR_WHITE, 12)
		debug_string = debug_string + "Etheral"
	else
		debug_string = debug_string + "Incompatiable"
	end
	//print(debug_string)
end

local function fang_handler(mo)
	if mo.state == S_FANG_INTRO1 and not mo.fang_real
		mo.fang_real = true
	end
	if	gibs_organic == false
		return
	end
	if mo.state == S_FANG_KO
		A_Create_Liquid(mo, 1, 10, SKINCOLOR_RED, 10)
		A_Create_Liquid(mo, 2, 8, SKINCOLOR_RED, 12)
		A_Create_Liquid(mo, 3, 6, SKINCOLOR_RED, 14)
		A_Create_Gibs(mo,3,11,16,SKINCOLOR_RED)
		A_Create_Gibs(mo,4,0,4,SKINCOLOR_RED)
		P_RemoveMobj(mo)
	end
end

freeslot("SPR_SBDY", "MT_SONIC_CORPSE", "S_SONIC_CORPSE1", "S_SONIC_CORPSE2")

mobjinfo[MT_SONIC_CORPSE] = {
	doomednum = -1,
	spawnstate = S_SONIC_CORPSE1,
	radius = 20*FRACUNIT,
	height = 40*FRACUNIT,
	flags = MF_BOUNCE
}

states[S_SONIC_CORPSE1] = {SPR_SBDY, A, -1, nil, 0, 0, S_SONIC_CORPSE1}
states[S_SONIC_CORPSE2] = {SPR_SBDY, B, -1, nil, 0, 0, S_SONIC_CORPSE2}

addHook("MobjThinker", function(mobj)
	if (P_IsObjectOnGround(mobj))
		mobj.state = S_SONIC_CORPSE2
	else
		mobj.state = S_SONIC_CORPSE1
	end
end, MT_SONIC_CORPSE)

local function metal_handler(mo)
	if mo.metal_dead == 1
		S_StopSound(mo)
		P_SpawnMobj(mo.x, mo.y, mo.z, MT_SONIC_CORPSE)
		P_TeleportMove(mo, mo.x, mo.y, mo.z + 1024*FRACUNIT)
		mo.metal_dead = 2
	end
	if mo.metal_dead
		mo.flags2 = MF2_DONTDRAW
	end
end


local function brak_handler(mo)
	if mo.state == S_CYBRAKDEMON_DIE6
		A_Create_Liquid(mo, 1, 10, SKINCOLOR_BLACK, 10)
		A_Create_Liquid(mo, 2, 8, SKINCOLOR_BLACK, 12)
		A_Create_Liquid(mo, 3, 6, SKINCOLOR_BLACK, 16)
		A_Create_Gibs(mo,1,6,32,SKINCOLOR_BLACK)
		A_Create_Gibs(mo,2,6,32,SKINCOLOR_BLACK)
		if gibs_organic == true
			A_Create_Liquid(mo, 1, 10, SKINCOLOR_RED, 10)
			A_Create_Liquid(mo, 2, 8, SKINCOLOR_RED, 12)
			A_Create_Liquid(mo, 3, 6, SKINCOLOR_RED, 16)
			A_Create_Gibs(mo,3,6,32,SKINCOLOR_RED)
			A_Create_Gibs(mo,4,6,32,SKINCOLOR_RED)
		end
		for player in players.iterate
			P_FlashPal(player, PAL_WHITE, 8)
		end
		S_StartSound(nil,sfx_bkpoof)
		P_RemoveMobj(mo)
	end
end

local function player_handler(mo)
	if mo.skull and mo.skull.valid then
		P_TeleportMove(mo,mo.skull.x,mo.skull.y,mo.skull.z)
		mo.angle = mo.skull.angle
		mo.height = mo.skull.height
		mo.flags2 = MF2_DONTDRAW
	end
end

addHook("MobjDeath", gib_handler, MT_NULL)
addHook("MobjThinker", fang_handler, MT_FANG)
addHook("MobjThinker", metal_handler, MT_METALSONIC_BATTLE)
addHook("MobjThinker", brak_handler, MT_CYBRAKDEMON)
addHook("MobjThinker", player_handler, MT_PLAYER)