freeslot("sfx_amngs", "sfx_amngvc", "sfx_amngls", "tol_arena")
sfxinfo[sfx_amngs].caption = ""
sfxinfo[sfx_amngvc].caption = "Victory"
sfxinfo[sfx_amngls].caption = "Lose"

G_AddGametype({
    name = "EXE Terrorism",
    identifier = "exeamongus",
    typeoflevel = TOL_ARENA|TOL_MATCH,
    rules = GTR_OVERTIME|GTR_STARTCOUNTDOWN|GTR_BLINDFOLDED|GTR_RESPAWNDELAY|GTR_SPECTATORS|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_SPAWNINVUL|GTR_DEATHMATCHSTARTS,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 0,
    headerleftcolor = 253,
    headerrightcolor = 254,
    description = "Sonic.EXE is disguised as an innocent, he will kill everyone. As an innocent you need to survive and find out who he is, and to not look suspicious."
})

local version = "1.1"

local gamestate = "waiting"
local gametime = 0
local roundstartcountdown = 0
local PossibleCandidates = {}
local Innocents = {}
local Detectives = {}
local KILLERs = {}
local endedtime = 0
local winner

//icon thinker for the player list.
local function IconThinker()
	for player in players.iterate
		if not (player.mo and player.mo.valid and player.rings > 0) then continue end
		player.skin = player.mo.skin
	end
end

addHook("ThinkFrame", IconThinker)

//detectives are cool because they can sense KILLERs within a certain radius
local function KILLERIsNear(player)
	for i = 1, #KILLERs
		if player.mo and KILLERs[i].mo
			if R_PointToDist2(player.mo.x, player.mo.y, KILLERs[i].mo.x, KILLERs[i].mo.y) < 1024*FRACUNIT
				return true
			end
		end
	end
	return false
end

local function GameHud(v, stplyr)
	if gametype != GT_EXEAMONGUS or not netgame then return end
	local seconds, centiseconds
	if roundstartcountdown
		seconds = G_TicsToSeconds(roundstartcountdown)
		centiseconds = G_TicsToCentiseconds(roundstartcountdown)
	end
	if stplyr.spectator and stplyr.dead
		v.drawString(160, 91, "You died. You cannot", V_REDMAP|V_ALLOWLOWERCASE, "center")
		v.drawString(160, 101, "respawn until the next round.", V_REDMAP|V_ALLOWLOWERCASE, "center")
	end
	if stplyr.spectator and stplyr.cannotjoin and not stplyr.dead
		v.drawString(160, 91, "You cannot join the game", V_REDMAP|V_ALLOWLOWERCASE, "center")
		v.drawString(160, 101, "until the next round.", V_REDMAP|V_ALLOWLOWERCASE, "center")
	end
	if stplyr.mo and stplyr.team and gamestate == "midgame" and gametime < 8*TICRATE
		if stplyr.team == "exe"
			v.drawString(160, 184, "YOU ARE A KILLER", V_REDMAP, "center")
		elseif stplyr.team == "innocent"
			v.drawString(160, 184, "YOU ARE INNOCENT", V_GREENMAP, "center")
		elseif stplyr.team == "detective"
			v.drawString(160, 184, "YOU ARE A DETECTIVE", V_BLUEMAP, "center")
		end
	end
	if gamestate == "midgame" and gametime < 8*TICRATE
		local sprite = v.getSprite2Patch(stplyr.mo.skin, SPR2_STND)
		v.drawScaled(0,0,20*FRACUNIT,v.cachePatch("BLACK"),V_SNAPTOLEFT|V_SNAPTOTOP)
		if stplyr.team == "exe"
			sprite = v.getSprite2Patch("exetior", SPR2_STND)
			v.drawString(160, 32, "YOU ARE A KILLER", V_REDMAP, "center")
		elseif stplyr.team == "innocent"
			v.drawString(160, 32, "YOU ARE INNOCENT", V_GREENMAP, "center")
		elseif stplyr.team == "detective"
			v.drawString(160, 32, "YOU ARE A DETECTIVE", V_BLUEMAP, "center")
		end
		v.draw(160-4,160-16, sprite, 0, v.getColormap(-1, stplyr.mo.color))
		if gametime < TICRATE/4
			v.drawScaled(0,0,20*FRACUNIT,v.cachePatch("BLACK"),V_SNAPTOLEFT|V_SNAPTOTOP)
		end
		if gametime < TICRATE/2 and gametime > TICRATE/4
			v.drawScaled(0,0,20*FRACUNIT,v.cachePatch("BLACK"),V_SNAPTOLEFT|V_SNAPTOTOP|V_40TRANS)
		end
		if gametime < TICRATE and gametime > TICRATE/2
			v.drawScaled(0,0,20*FRACUNIT,v.cachePatch("BLACK"),V_SNAPTOLEFT|V_SNAPTOTOP|V_70TRANS)
		end
		if gametime > 7*TICRATE and gametime <= 7*TICRATE+TICRATE/2
			v.drawScaled(0,0,20*FRACUNIT,v.cachePatch("BLACK"),V_SNAPTOLEFT|V_SNAPTOTOP|V_70TRANS)
		end
		if gametime > 7*TICRATE+TICRATE/2 and gametime <= 7*TICRATE+TICRATE/2+TICRATE/4
			v.drawScaled(0,0,20*FRACUNIT,v.cachePatch("BLACK"),V_SNAPTOLEFT|V_SNAPTOTOP|V_40TRANS)
		end
		if gametime > 7*TICRATE+TICRATE/2+TICRATE/4 and gametime <= 8*TICRATE+TICRATE/2
			v.drawScaled(0,0,20*FRACUNIT,v.cachePatch("BLACK"),V_SNAPTOLEFT|V_SNAPTOTOP)
		end
	end
	if gametime >= 8*TICRATE and gametime <= 8*TICRATE+TICRATE/2 
		v.drawScaled(0,0,20*FRACUNIT,v.cachePatch("BLACK"),V_SNAPTOLEFT|V_SNAPTOTOP|V_50TRANS)
	end
	if PossibleCandidates and gamestate == "waiting" then
		local textcolor, text
		if #PossibleCandidates >= 4
			textcolor = V_GREENMAP
			if stplyr == server
				text = "TOSS FLAG TO START"
			else text = "WAITING FOR HOST"
			end
		else textcolor = V_YELLOWMAP
			text = "WAITING FOR PLAYERS"
		end
		v.drawString(160, 4, text, textcolor, "center")
		v.drawString(160, 14, #PossibleCandidates+"/4", 0, "center")
		local numt = #PossibleCandidates/3
		local numd = ""
		local teamnums = "\x83"..#PossibleCandidates-(numt+numd).."  \x85"..numt.."  \x84"..numd
		v.drawString(160-(v.stringWidth(teamnums, 0, "small")/2), 24, teamnums, 0, "small")
	end
	if gamestate == "countdown"
		v.drawString(160, 4, "ROUND STARTS IN", V_YELLOWMAP, "center")
		if (seconds != nil and centiseconds != nil)
			if centiseconds < 10
				v.drawString(149, 14, seconds, 0)
				v.drawString(159, 18, "."+centiseconds+"0", 0, "small")
			else v.drawString(149, 14, seconds, 0)
				v.drawString(159, 18, "."+centiseconds, 0, "small")
			end
		end
	end
	
	if stplyr.team == "detective" and KILLERIsNear(stplyr) and leveltime % 35 > 17
		local article //Why am I doing this...?
		if #KILLERs > 1
			article = "A "
		else article = "THE "
		end
		v.drawString(160, 32, article.."KILLER IS NEARBY", V_REDMAP, "center")
	end
	
	local color
	if (stplyr.spectator and not stplyr.dead)
		color = 0
	elseif stplyr.team == winner or (winner == "innocent" and stplyr.team == "detective")
		color = V_GREENMAP
	else color = V_REDMAP
	end
	if gamestate == "end"
		if winner == "exe"
			v.drawString(160, 32, "KILLERS WIN", color, "center")
		elseif winner == "innocent"
			v.drawString(160, 32, "INNOCENTS WIN", color, "center")
		end
	end
end

local function PlayerList(v, stplyr)
	if gametype != GT_EXEAMONGUS or not netgame then return end
	v.drawString(316, 4, "PLAYERS", V_YELLOWMAP, "right")
	local ypos = 6
	for player in players.iterate
		if not player.valid then continue end
		local icon
		if player.spectator and not player.dead then continue end
		ypos = $1+10
		if (player.mo and player.mo.valid)
			local icon = v.getSprite2Patch(player.mo.skin, SPR2_LIFE)
			v.drawScaled(306*FRACUNIT, ypos*FRACUNIT, FRACUNIT/2, icon, 0, v.getColormap(player.mo.skin, player.skincolor))
		end
		if player != stplyr and player.team == "detective"
			v.drawString(304, ypos+2, player.name, V_BLUEMAP|V_ALLOWLOWERCASE, "small-right")
		elseif player != stplyr and player.team == "exe" and stplyr.team == "exe"
			v.drawString(304, ypos+2, player.name, V_REDMAP|V_ALLOWLOWERCASE, "small-right")
		elseif player == stplyr
			local color
			if stplyr.team == "detective"
				color = "\x84"
			elseif stplyr.team == "exe"
				color = "\x85"
			elseif stplyr.team == "innocent"
				color = "\x83"
			else 
				color = "\x80"
			end
			v.drawString(304, ypos+2, color+player.name, V_ALLOWLOWERCASE, "small-right")
		else 
			v.drawString(304, ypos+2, player.name, V_ALLOWLOWERCASE, "small-right")
		end
	end
end

local function RingsAndTime(v, stplyr)
	if gametype != GT_EXEAMONGUS or not netgame then return end
	if leveltime % 35 > 17 and stplyr.rings == 1
		v.drawString(4, 4, "RINGS", V_REDMAP)
	else v.drawString(4, 4, "RINGS", V_YELLOWMAP)
	end
	if stplyr.rings > 0
		v.drawString(24, 12, stplyr.rings-1, 0, "center")
	else v.drawString(24, 12, "0", 0, "center")
	end
	if gametime and (gamestate == "midgame")
		local mins = G_TicsToMinutes(gametime)
		local secs = G_TicsToSeconds(gametime)
		local concat
		if secs < 10
			concat = ":0"
		else concat = ":"
		end
		v.drawString(160, 4, "TIME", V_YELLOWMAP, "center")
		v.drawString(160, 12, mins+concat+secs, 0, "center")
		v.drawString(300, 168, "RINGS TO WIN", V_YELLOWMAP|V_SNAPTOBOTTOM|V_SNAPTORIGHT, "right")
		v.drawString(300, 180, tostring(server.collectedrings)+"/"+tostring(server.amountrings), V_SNAPTOBOTTOM|V_SNAPTORIGHT, "right")
	end
end

local function TabMenu(v)
	if gametype != GT_EXEAMONGUS or not netgame then return end
end

hud.add(GameHud, "game")
hud.add(PlayerList, "game")
hud.add(RingsAndTime, "game")
hud.add(TabMenu, "scores")

addHook("ThinkFrame", do
	if gametype == GT_EXEAMONGUS and netgame
		hud.disable("rankings")
		hud.disable("score")
		hud.disable("time")
		hud.disable("rings")
	else
		hud.enable("rankings")
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
	end
	
	if gametype != GT_EXEAMONGUS
		gamestate = nil
	end
end)

local function BringBackTheDead()
	if gametype != GT_EXEAMONGUS or not netgame then return end
	for player in players.iterate
		if (player.valid and player.dead == true)
			player.dead = false
			player.cannotjoin = false
			player.ctfteam = 1
		end
	end
end

local function DoGameWin(team)
	if gametype != GT_EXEAMONGUS or not netgame then return end
	gamestate = "end"
	winner = team
	for player in players.iterate
		if (player.valid) and ((player.team and player.team == winner) or (player.team and winner == "innocent"
		and player.team == "detective"))
			S_StartSound(nil, sfx_amngvc, player)
		elseif player.team != winner and not (player.spectator and not player.dead)
			S_StartSound(nil, sfx_amngls, player)
		end
	end
end

local function PickKILLERs(x)
	if gametype != GT_EXEAMONGUS or not netgame then return end
	for i = 1, x do
		local KILLER = PossibleCandidates[P_RandomRange(1, #PossibleCandidates)]
		if KILLER.valid and KILLER.mo
			KILLER.team = "exe"
			KILLER.mo.killtimer = 1800*TICRATE
			table.insert(KILLERs, KILLER)
			for i in ipairs(PossibleCandidates)
				if PossibleCandidates[i] != KILLER then continue end
				table.remove(PossibleCandidates, i)
			end
		end
	end
end

local function PickDetectives(x)
	if x == 0 or gametype != GT_EXEAMONGUS or not netgame then return end
end
	
local function DoTeams()
	if gametype != GT_EXEAMONGUS or not netgame then return end
	if not #PossibleCandidates then return end
	local num = #PossibleCandidates
	local numKILLERs = num/2 //Originally ~1:4, this can always change
	local numdetectives = num/4 //Originally ~1:8, this can always change
	PickKILLERs(numKILLERs)
	PickDetectives(numdetectives)
	for mobj in mobjs.iterate()
		if mobj.type == MT_RING
			server.amountrings = $ + 1
		end
	end
	server.amountrings = $ / 2
	for player in players.iterate
		if player.team != "exe" and player.team != "detective"
			server.amountrings = $ + $
			player.team = "innocent"
			table.insert(Innocents, player)
		end
	end
end

local function AddToCandidates(player)
	if gametype != GT_EXEAMONGUS or not netgame then return end
	for i in ipairs(PossibleCandidates)
		if PossibleCandidates[i] == player
			return false
		end
	end
	table.insert(PossibleCandidates, player)
end

addHook("PlayerMsg", function(sender, type, target, msg)
	if gametype != GT_EXEAMONGUS or not netgame or gamestate != "midgame" then return end
	
	local name = sender.name
	if sender == server
		name = "~"+sender.name
	elseif admin != nil and sender == admin
		name = "@"+sender.name
	end
	
	if (type == 0 or type == 1)
		for player in players.iterate
			if (sender.spectator and player.spectator)
				if string.find(msg, "/me ")
					local memessage = string.gsub(("\x03\x86"+name+msg), "/me ", "\x82 ")
					CONS_Printf(player, memessage) //funny meme
				else CONS_Printf(player, ("\x03<\x86"+name+"\x80> "+msg))
				end
			end
			if (not sender.spectator) and sender.team and sender.team == "exe"
				local tcolor
				if player.team and player.team == "exe"
					tcolor = "\x85"
				else tcolor = "\x83"
				end
				if type == 0 and string.find(msg, "/me ")
					local memessage = string.gsub(("\x03"+tcolor+name+msg), "/me ", "\x82 ")
					CONS_Printf(player, memessage)
				elseif type == 1 and player.team == "exe"
					CONS_Printf(player, ("\x03>>\x85"+name+"\x80<< (TO KILLERS)"+msg))
				else CONS_Printf(player, ("\x03<"+tcolor+name+"\x80> "+msg))
				end
			elseif (not sender.spectator) and sender.team and sender.team == "innocent"
				if string.find(msg, "/me ")
					local memessage = string.gsub(("\x03\x83"+name+msg), "/me ", "\x82 ")
					CONS_Printf(player, memessage)
				else CONS_Printf(player, ("\x03<\x83"+name+"\x80> "+msg))
				end
			elseif not (sender.spectator) and sender.team and sender.team == "detective"
				if string.find(msg, "/me ")
					local memessage = string.gsub(("\x03\x84"+name+msg), "/me ", "\x82 ")
					CONS_Printf(player, memessage)
				else CONS_Printf(player, ("\x03<\x84"+name+"\x80> "+msg))
				end
			end
		end
	elseif type == 2
		if sender.spectator
			if target.spectator
				CONS_Printf(target, ("\x03\x86**"+name+"** \x80"+msg))
			else CONS_Printf(sender, "\x85You can only send messages to other spectators.")
			end
		elseif sender.team and sender.team == "exe" and target.team and target.team == "exe"
			CONS_Printf(target, ("\x03\x85**"+name+"** \x80"+msg))
			if sender != target
				CONS_Printf(sender, ("\x03->*"+name+"* \x80"+msg))
			end
		elseif sender.team and sender.team == "detective"
			CONS_Printf(target, ("\x03\x84**"+name+"** \x80"+msg))
			if sender != target
				CONS_Printf(sender, ("\x03->*"+name+"* \x80"+msg))
			end
		else CONS_Printf(target, ("\x03\x83**"+name+"** \x80"+msg))
			if sender != target
				CONS_Printf(sender, ("\x03->*"+name+"* \x80"+msg))
			end
		end
	elseif type == 3
		if sender.spectator
			CONS_Printf(sender, "\x85You cannot use csay as a spectator.")
			S_StartSound(nil, sfx_lose, sender)
		else return false
		end
	end
	return true
end)

addHook("MapChange", do
	if gametype != GT_EXEAMONGUS or not netgame
	else
		PossibleCandidates = {}
		gamestate = "waiting"
		BringBackTheDead()
		winner = nil
		Innocents = {}
		Detectives = {}
		KILLERs = {}
		endedtime = 0
	end
end)

local function WaitingThinker()
	if gametype != GT_EXEAMONGUS or not netgame then return end
	if gamestate != "waiting" then return end
	
	server.amountrings = 0
	server.collectedrings = 0
	
	//Remove non-playing players from playing players
	for i in ipairs(PossibleCandidates)
		if PossibleCandidates[i].valid and PossibleCandidates[i].mo
			PossibleCandidates[i].powers[pw_shield] = SH_NONE
			PossibleCandidates[i].powers[pw_flashing] = 2
			PossibleCandidates[i].powers[pw_underwater] = 30*TICRATE
		end
		if (not PossibleCandidates[i].valid) or PossibleCandidates[i].spectator
		or PossibleCandidates[i].dead or PossibleCandidates[i].cannotjoin
			table.remove(PossibleCandidates, i)
		end
	end
	
	for player in players.iterate
		if player.mo and not player.spectator and not player.dead
			AddToCandidates(player)
		end
		player.dead = false
		player.cannotjoin = false
		player.team = nil
	end
	
	if #PossibleCandidates >= 4
		if (not server.valid) or (server.valid and (server.cmd.buttons & BT_TOSSFLAG))
			roundstartcountdown = 350
			gamestate = "countdown"
		end
	end
end

local function CountdownThinker()
	if gametype != GT_EXEAMONGUS or not netgame then return end
	if gamestate != "countdown" then return end
	
	for player in players.iterate
		if player.mo and not player.spectator and not player.team and not player.dead
			AddToCandidates(player)
		else
			for i in ipairs(PossibleCandidates)
				if i != player then continue end
				table.remove(PossibleCandidates, i)
			end
		end
		player.dead = false
	end
	
	if roundstartcountdown > 0 and gamestate == "countdown" //Countdown ticker
		roundstartcountdown = $1-1
	else 
		gamestate = "midgame"
	end
	
	gametime = 0
	
	if roundstartcountdown == 35
		DoTeams()
	end
	
	if #PossibleCandidates < 2 and roundstartcountdown > 35 //Go back to waiting
		gamestate = "waiting"
		roundstartcountdown = 0
		for player in players.iterate
			player.team = nil
		end
	end
	
	for i in ipairs(PossibleCandidates)
		if PossibleCandidates[i].valid and PossibleCandidates[i].mo
			PossibleCandidates[i].powers[pw_shield] = SH_NONE
			PossibleCandidates[i].powers[pw_flashing] = 2
			PossibleCandidates[i].powers[pw_underwater] = 30*TICRATE
		end
	end
end

addHook("MobjDeath", function(ring)
	if (gametype == GT_EXEAMONGUS) and (gamestate == "midgame")
		server.collectedrings = $ + 1
	end
end, MT_RING)

local function GameThinker()
	if gametype != GT_EXEAMONGUS or not netgame then return end
	if gamestate != "midgame" then return end
	if not (server.amountrings) return end
	gametime = $1+1
	if (gametime == 1)
		S_StartSound(nil, sfx_amngs)
	end
	if (gametime < 8*TICRATE)
		for p in players.iterate
			p.pflags = $1|PF_FULLSTASIS
		end
	else
		if (gametime == 8*TICRATE)
			for p in players.iterate
				S_ChangeMusic(mapheaderinfo[gamemap].musname, true, p, 0, 0, 0, 1000)
			end
		end
	end
	for i in ipairs(Innocents) //Remove bad players from innocents
		if (not Innocents[i].valid) or Innocents[i].dead or Innocents[i].spectator
			table.remove(Innocents, i)
		end
	end
	
	for i in ipairs(Detectives) //Remove bad players from detectives
		if (not Detectives[i].valid) or Detectives[i].dead or Detectives[i].spectator
			table.remove(Detectives, i)
		end
	end
	
	for i in ipairs(KILLERs) //Remove bad players from KILLERs
		if (not KILLERs[i].valid) or KILLERs[i].dead or KILLERs[i].spectator
			table.remove(KILLERs, i)
		end
	end
	
	if #KILLERs == 0
		DoGameWin("innocent")
		print("\x82ROUND ENDED: All killers have been eliminated.")
	elseif (server.collectedrings >= server.amountrings)
		DoGameWin("innocent")
		print("\x82ROUND ENDED: Innocents got the necessary amount of rings.")
		server.collectedrings = 0
		server.amountrings = 0
	elseif #Innocents == 0 and #Detectives == 0
		DoGameWin("exe")
		print("\x82ROUND ENDED: All innocents have been eliminated.")
	end
	
	for player in players.iterate
		player.powers[pw_shield] = SH_NONE
		if player.dead or player.cannotjoin
			player.spectator = true
			player.powers[pw_flashing] = 2
		end
		
		if player.spectator
			player.cannotjoin = true
		else player.cannotjoin = false
		end
		
		if player.mo
			if player.mo.killtimer and player.mo.killtimer > 0
				player.mo.killtimer = $1-1
				if player.mo.killtimer == 60*TICRATE
					CONS_Printf(player, "\x85You have one minute to kill an innocent or you will be killed.")
				elseif player.mo.killtimer == 30*TICRATE
					CONS_Printf(player, "\x85You have 30 seconds to kill an innocent or you will be killed.")
				elseif player.mo.killtimer == 10*TICRATE
					CONS_Printf(player, "\x85You have 10 seconds to kill an innocent or you will be killed.")
				end
			elseif player.mo.killtimer != nil and player.mo.killtimer == 0
				P_DamageMobj(player.mo, nil, nil, 10000)
				CONS_Printf(player, "\x85You did not kill an innocent in time.")
			end
		end
	end
end

local function EndThinker()
	if gametype != GT_EXEAMONGUS or not netgame then return end
	if gamestate != "end" then return end
	if endedtime == 350 //10 seconds after match end
		gamestate = "waiting"
		BringBackTheDead()
		G_ExitLevel()
		for player in players.iterate
			player.team = nil
		end
	end
	
	endedtime = $1+1
	
	for player in players.iterate
		player.weapondelay = 2
	end
end

local function MonitorThinker(mo) //TTT monitor balancing & no pre-round monitors
	if gametype != GT_EXEAMONGUS or not netgame or (gamestate ~= "midgame") then return end
	if (mo.flags & MF_MONITOR)
		return false
	end
end

//Death detection, better than mobjdamage at least.
local function PlayerThinker()
	if gametype != GT_EXEAMONGUS or not netgame then return end
	for player in players.iterate
		if (not player.mo) then continue end
		if gamestate == "midgame" and player.playerstate == PST_DEAD
			player.dead = true
		end
		if gamestate != "midgame"
			S_StopMusic(player)
		end
	end
end

addHook("ThinkFrame", WaitingThinker)
addHook("ThinkFrame", CountdownThinker)
addHook("ThinkFrame", GameThinker)
addHook("ThinkFrame", EndThinker)
addHook("MobjDamage", MonitorThinker)
addHook("ThinkFrame", PlayerThinker)

addHook("HurtMsg", do //Don't spoil the KILLER.
	if gametype == GT_EXEAMONGUS and netgame then
		return true
	end
end)

local function NoPreRoundCollectibles()
	if gamestate == "waiting" or gamestate == "countdown"
		return true
	end
end

addHook("ViewpointSwitch", function(player, player2)
	if (gametype == GT_EXEAMONGUS)
		return false
	end
end)

addHook("TouchSpecial", NoPreRoundCollectibles, MT_RING)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_EXPLOSIONRING)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_AUTOMATICRING)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_SCATTERRING)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_BOUNCERING)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_RAILRING)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_GRENADERING)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_INFINITYRING)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_EXPLODEPICKUP)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_AUTOPICKUP)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_SCATTERPICKUP)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_BOUNCEPICKUP)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_RAILPICKUP)
addHook("TouchSpecial", NoPreRoundCollectibles, MT_GRENADEPICKUP)

addHook("MobjMoveCollide", function(mo1, mo2)
	if (mo1.valid) and (mo2.valid)
	and (mo1.player) and (mo2.player)
	and ((mo1.player.pflags & PF_JUMPED) or (mo1.player.pflags & PF_SPINNING))
	and (gametype == GT_EXEAMONGUS)
	and not (P_PlayerInPain(mo2.player))
	and not (mo2.player.powers[pw_flashing]) 
    and not (mo2.player.powers[pw_super]) 
	and (gamestate == "midgame")
    and not ((mo2.player.pflags & PF_JUMPED) or (mo2.player.pflags & PF_SPINNING))
	and ((mo1.z >= mo2.z) and (mo1.z < mo2.z+mo2.height) or (mo2.z >= mo1.z) and (mo2.z < mo1.z+mo1.height))
		P_KillMobj(mo2)
		if (mo1.player.team == "exe")
			mo2.killtimer = 1800*TICRATE
		end
	end
end, MT_PLAYER)

addHook("MobjMoveCollide", function(mo1,mo2)
   if (mo1.valid and mo2.valid and mo1.player and mo2.player)
   and ((mo1.player.pflags & PF_JUMPED) or (mo1.player.pflags & PF_SPINNING))
   and ((mo2.player.pflags & PF_JUMPED) or (mo2.player.pflags & PF_SPINNING))
   and ((mo1.z >= mo2.z) and (mo1.z < mo2.z+mo2.height) or (mo2.z >= mo1.z) and (mo2.z < mo1.z+mo1.height))
   and (gametype == GT_EXEAMONGUS)
   and (gamestate == "midgame")
	   if (mo1.player.pflags & PF_STARTDASH)
			mo1.player.pflags = $1 & ~PF_STARTDASH
			mo1.player.pflags = $1|PF_SPINNING
			mo1.state = S_PLAY_ROLL
			P_InstaThrust(mo1, R_PointToAngle2(0,0,mo2.momx,mo2.momy), -mo2.player.speed/2)
		else
			mo1.momx = -$/2
			mo1.momy = -$/2		
	   end
	   if (mo2.player.pflags & PF_STARTDASH)
			mo2.player.pflags = $1 & ~PF_STARTDASH
			mo2.player.pflags = $1|PF_SPINNING
			mo2.state = S_PLAY_ROLL
			P_InstaThrust(mo2, R_PointToAngle2(0,0,mo1.momx,mo1.momy), -mo1.player.speed/2)
		else
			mo2.momx = -$/2
			mo2.momy = -$/2		
	   end
	   return true
   end
end, MT_PLAYER)