freeslot("sfx_exeapr", "sfx_exedis", "sfx_rngexe")
sfxinfo[sfx_exeapr].caption = "Disappear"
sfxinfo[sfx_exedis].caption = "Appear"
sfxinfo[sfx_rngexe].caption = "Activation"

G_AddGametype({
    name = "EXE Survival",
    identifier = "exesurvival",
    typeoflevel = TOL_MATCH,
    rules = GTR_OVERTIME|GTR_STARTCOUNTDOWN|GTR_TAG|GTR_BLINDFOLDED|GTR_RESPAWNDELAY|GTR_SPECTATORS|GTR_POINTLIMIT|GTR_TIMELIMIT|GTR_SPAWNINVUL|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 5,
    headerleftcolor = 35,
    headerrightcolor = 42,
    description = "Who's ever chosen to be Sonic.EXE will hunt down his victims, if they get caught they become his servant."
})

local function firstToUpper(str)
    return (str:gsub("^%l", string.upper))
end

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid and player.mo.skin ~= "sonic" and player.mo.skin ~= "exetior" and gametype == GT_EXESURVIVAL)
		CONS_Printf(player, "You cannot play as "..firstToUpper(tostring(player.mo.skin)).." in EXE Survival!")
		S_StartSound(nil, sfx_lose, player)
		R_SetPlayerSkin(player, "sonic")
	end
end)

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and (gametype == GT_EXESURVIVAL)
		player.wasexe = $ or 0
		player.mindfuckery = $ or 0
		player.mindfuckerycount = $ or 0
		player.disappeartimer = $ or 0
		player.disappearcount = $ or 0
		player.dpressed = $ or 0 //i really wanted to call this variable "depressed" lol
		player.mpressed = $ or 0
		player.mashed = $ or 0
		if (leveltime == 0)
			player.wasexe = 0
		end
		COM_BufInsertText(server, "touchtag 1")
		if (player.pflags & PF_TAGIT)
			if (player.mindfuckery ~= 0)
				player.jumpfactor = skins[player.mo.skin].jumpfactor
				COM_BufInsertText(player, "tunes -default")
				player.normalspeed = 36*FRACUNIT
				player.mindfuckery = 0
				COM_BufInsertText(player, "fov 90")
			end
			if (player.wasexe == 1)
				if (player.mindfuckerycount == 0) and (player.cmd.buttons & BT_CUSTOM2) and (player.mpressed == 0)
					for p in players.iterate
						if p.mo and p.mo.valid and not (p.pflags & PF_TAGIT)
							p.mindfuckery = 30
							p.mindposx = p.mo.x
							p.mindposy = p.mo.y
							p.mindposz = p.mo.z
						end
					end
					P_SpawnGhostMobj(player.mo)
					player.mpressed = 1
					player.mindfuckerycount = 120*TICRATE
					S_StartSound(player.mo, sfx_exeapr)
				elseif not (player.cmd.buttons & BT_CUSTOM2)
					player.mpressed = 0
				end				
			else
				player.mindfuckerycount = 0
			end
			if (player.disappeartimer == 0)
			and (player.disappearcount > 0)
				player.disappearcount = $ - 1
			end
			if (player.mindfuckerycount > 0)
				player.mindfuckerycount = $ - 1
			end
			if (player.disappearcount == 0) and (player.disappeartimer == 0) and (player.cmd.buttons & BT_CUSTOM1) and (player.dpressed == 0)
				P_SpawnGhostMobj(player.mo)
				player.dpressed = 1
				player.disappeartimer = 10*TICRATE
				S_StartSound(player.mo, sfx_exeapr)
			elseif (player.disappearcount == 0) and (player.disappeartimer > 0) and (player.cmd.buttons & BT_CUSTOM1) and (player.dpressed == 0)
				player.dpressed = 1
				player.disappeartimer = 0
				player.disappearcount = 15*TICRATE
				S_StartSound(player.mo, sfx_exedis)
			elseif not (player.cmd.buttons & BT_CUSTOM1)
				player.dpressed = 0
			end
			if (player.disappeartimer ~= 0)
				player.mo.flags2 = $|MF2_DONTDRAW
			else
				player.mo.flags2 = $ & ~MF2_DONTDRAW
			end
			if (player.disappeartimer > 0)
				if (player.disappeartimer == 1)
					player.disappearcount = 15*TICRATE
					S_StartSound(player.mo, sfx_s3k92)
				end
				player.disappeartimer = $ - 1
			end
			if (leveltime < (CV_FindVar("hidetime").value*TICRATE))
				player.wasexe = 1
			end
			if (player.wasexe == 0)
				player.mo.colorized = true
				player.mo.color = SKINCOLOR_GREY
			else
				R_SetPlayerSkin(player, "exetior")
			end
			player.normalspeed = 36*FRACUNIT
		else
			if (player.mo.skin == "exetior")
				R_SetPlayerSkin(player, "sonic")
			end
			player.mindfuckerycount = 0
			if (player.mindfuckery > 0)
				if (player.mindpos)
					player.mo.state = S_PLAY_STND
					P_TeleportMove(player.mo, player.mindposx, player.mindposy, player.mindposz)
				end
				COM_BufInsertText(player, "tunes mindfk")
				COM_BufInsertText(player, "fov "+tostring(90-player.mindfuckery*3))
				P_FlashPal(player, 5, 1)
				player.jumpfactor = 0
				player.normalspeed = 4*FRACUNIT
				if (player.mashed == 0) and (player.cmd.buttons & BT_JUMP)
					if (player.mindfuckery == 1)
						player.jumpfactor = skins[player.mo.skin].jumpfactor
						COM_BufInsertText(player, "tunes -default")
						player.normalspeed = 32*FRACUNIT
						player.powers[pw_nocontrol] = 10
					end
					player.mo.momx = P_RandomRange(-5,5)*FRACUNIT
					player.mo.momy = P_RandomRange(-5,5)*FRACUNIT
					player.mashed = 1
					player.mindfuckery = $ - 1
					S_StartSound(nil, sfx_s3kd7s, player)
				elseif not (player.cmd.buttons & BT_JUMP)
					player.mashed = 0
				end
			else
				player.jumpfactor = skins[player.mo.skin].jumpfactor
				player.normalspeed = 32*FRACUNIT
			end
		end
	end
end)

hud.add(function(v, player)
	if not (player.pflags & PF_TAGIT) return end
	if (gametype ~= GT_EXESURVIVAL) return end
	if (leveltime < (CV_FindVar("hidetime").value*TICRATE)) return end
		local timeclock = v.cachePatch("RECCLOCK")
		v.drawScaled(16*FRACUNIT,56*FRACUNIT,FRACUNIT/4,timeclock,V_HUDTRANS|V_PERPLAYER)
	if (player.mo and player.mo.valid)
		if (player.disappeartimer ~= 0)
			v.drawString(28,56,"Disappear Timer: "+tostring(player.disappeartimer/TICRATE),V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER, "thin")
			v.drawString(28,64,"C1: Appear",V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER, "thin")
		elseif (player.disappeartimer == 0) and (player.disappearcount ~= 0)
			v.drawString(28,56,"Disappear Delay: "+tostring(player.disappearcount/TICRATE),V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER, "thin")
		elseif (player.disappeartimer == 0) and (player.disappearcount == 0)
			v.drawString(28,56,"C1: Disappear",V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER, "thin")
		end
		if (player.wasexe == 1)
			if (player.mindfuckerycount ~= 0)
				v.drawString(28,72,"Mindbreaker Delay: "+tostring(player.mindfuckerycount/TICRATE),V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER, "thin")
			else
				v.drawString(28,72,"C2: Mindbreaker",V_HUDTRANS|V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER, "thin")
			end
		end
	end
end)

addHook("MobjThinker", function(it)
	if (it.valid) and (gametype == GT_EXESURVIVAL)
		it.state = S_NULL
	end
end, MT_TAG)

//DO
//Resolution support
//Remove color fading
//Add "border" objects
//radar size varies with gametype

local test = 0
-- local radar_enabled = true
/*COM_AddCommand("radar",function(player)
	radar_enabled = not(radar_enabled)
	if radar_enabled then print("Object radar enabled.")
	else print("Object radar disabled.")
	end
end,1)
*/

//Colors
local c_white = 0
local c_silver = 6
local c_black = 31
local c_blue = 149
local c_darkblue = 154
local c_red = 34
local c_darkred = 40
local c_yellow = 72
local c_orange = 56
local c_green = 102
local c_purple = 180
local c_darkpurple = 184
local c_border = 27 //Color for radar borders
local color = c_white //Currently selected color
local bo = 2 //border offset

local function hudstuff(v, user, cam)
	if not(multiplayer)
		or maptol&TOL_NIGHTS 
		or (gametype == GT_HIDEANDSEEK and user.pflags&PF_TAGIT)
		then return
	end
	if (gametype ~= GT_EXESURVIVAL) return end //easy way though this is gonna make me copy this again for the radar in sp but i don't really care
	local umo = user.mo
	if umo == nil 
		or (user.pflags&PF_TAGIT and leveltime < (CV_FindVar("hidetime").value*TICRATE))
		then return
	end	
-- 	local test = user.rings
	//Setup radar
	local xscale = v.dupx()
	local yscale = v.dupx()
-- 	local unit = user.mo.scale
	local unit = FRACUNIT
	local radius = 128*12
	local fullsight = 128*32
	local radarsize = 48*xscale
	if gametype <= GT_COOP then
-- 		radius = 128*16
-- 		fullsight = 128*32
		radarsize = $*2/3
-- 		if splitscreen then return nil end
	end
	local hradius = radius
	if splitscreen then radarsize = $*2/3 end
	local center = radarsize/2
	
	//Alignment
-- 	local xpos = 8 //Left corner
-- 	local xpos = v.width()/v.dupx()-radarsize-16 //Right corner
	local xpos = v.width()-radarsize-8*xscale //Right corner
	local ypos = 8*yscale //Top corner
-- 	local ypos = 8 //Top corner
-- 	local ypos = v.height()/yscale-radarsize-32 //Bottom corner
	if splitscreen then //2-Player offsets
		ypos = $/2
		if user == secondarydisplayplayer then
			ypos = $+v.height()/2
		end
	end
	local xpos2 = xpos+radarsize-xscale
	local ypos2 = ypos+radarsize-yscale
	//Draw radar box
-- 	v.drawFill(xpos,ypos,radarsize,radarsize,c_black)
	v.drawFill(xpos,ypos,radarsize,radarsize,c_black|V_NOSCALESTART)
	//Draw borders
	v.drawFill(xpos+xscale,ypos+yscale,radarsize-xscale*2,yscale,c_border|V_NOSCALESTART) //Top border
	v.drawFill(xpos+xscale,ypos2-yscale,radarsize-xscale*2,yscale,c_border|V_NOSCALESTART) //Bottom border
	v.drawFill(xpos+xscale,ypos+yscale,xscale,radarsize-yscale*2,c_border|V_NOSCALESTART) //Left border
	v.drawFill(xpos2-xscale,ypos+yscale,xscale,radarsize-yscale*2,c_border|V_NOSCALESTART) //Right border
	
	if gametype > GT_RACE then
	//Search mobj and draw coordinates
		searchBlockmap("objects",function (umo,mo)
			if mo == nil or not(mo.health) then return nil end 
			local dist = R_PointToDist2(umo.x,umo.y,mo.x,mo.y)
			local zdist = abs(mo.z-umo.z)
			local flash1 = not(leveltime&15)
			local flash2 = not(leveltime&4)
			local size = xscale*2
			if splitscreen then 
				size = $*2/3
			end
			//Distance check
			if dist > fullsight*unit then return nil
			//Players
			elseif mo.type == MT_PLAYER then
				if mo.player.spectator then return nil end
				if (mo.player.disappeartimer > 0) and (dist >fullsight/6*unit) then return nil end
				if gametype == GT_EXESURVIVAL
					local it = mo.player.pflags&PF_TAGIT
					local notmyteam = mo.player.pflags&PF_TAGIT != user.pflags&PF_TAGIT
					if notmyteam and flash2 then
						color = c_yellow
					elseif it then
						color = c_red
					else
						color = c_blue
					end
				end
			//Badniks and bosses
			/*
			elseif mo.flags&MF_ENEMY
				then color = c_darkred
			elseif mo.flags&MF_BOSS
				then
				size = $*3/2
				color = c_darkred
			*/
			//Item pickups
	-- 		elseif (mo.flags&MF_MONITOR) and mo.health and not(mo.type == MT_RING_BOX) then color = c_green
			elseif (mo.type >= MT_BOUNCEPICKUP and mo.type <= MT_GRENADEPICKUP) then
				color = c_green
-- 				size = $*2/3
			elseif (mo.type == MT_TOKEN or (mo.type <= MT_EMERHUNT and mo.type >= MT_EMERALD1))
				if not(flash1) then color = c_orange
				else color = c_yellow
				end
-- 				size = $*2/3
			/*
			//Starpost
			elseif (mo.type == MT_STARPOST) then 
				if not(flash1) then color = c_purple
				else color = c_yellow
				end
			//Goalsign
			elseif (mo.type == MT_SIGN) then 
				if not(flash2) then color = c_purple
				else color = c_yellow
				end
			*/
			//CTF Flags
			elseif mo.type == MT_REDFLAG then
				if not(flash1) and not(mo.fuse and flash2) then
					color = c_darkred
				else 
					color = c_yellow
				end
-- 				size = $*2/3
			elseif mo.type == MT_BLUEFLAG then
				if not(flash1) and not(mo.fuse and flash2) then
					color = c_darkblue
				else
					color = c_yellow
				end
-- 				size = $*2/3
			else return nil
			end
	 		if zdist > hradius*unit then size = $*2/3 end
			local angle = umo.angle-R_PointToAngle2(umo.x,umo.y,mo.x,mo.y)+ANGLE_270
			local x = P_ReturnThrustX(nil,angle,dist)/unit*center/radius
			local y = P_ReturnThrustY(nil,angle,dist)/unit*center/radius
			local pushr = bo*xscale
			local pushl = bo*xscale
			if x <= -center+pushr or x >= center-pushl or y <= -center+pushr or y >= center-pushl then
				size = $/2
				x = max(pushr-center,min($,center-pushl))
				y = max(pushr-center,min($,center-pushl))
			end
			v.drawFill(xpos+x+center-size/2,ypos+y+center-size/2,size,size,color|V_NOSCALESTART)
	-- 		print(color)
			return nil
		end,umo,umo.x-fullsight*unit,umo.x+fullsight*unit,umo.y-fullsight*unit,umo.y+fullsight*unit)
	else
		for player in players.iterate
			local mo = player.mo
			if mo == nil or mo == umo or player.spectator or not(mo.health)
				then continue
			else color = c_blue
			end
			local size = xscale*2
			local dist = R_PointToDist2(umo.x,umo.y,mo.x,mo.y)
			local angle = umo.angle-R_PointToAngle2(umo.x,umo.y,mo.x,mo.y)+ANGLE_270
			local x = P_ReturnThrustX(nil,angle,dist)/unit*center/radius
			local y = P_ReturnThrustY(nil,angle,dist)/unit*center/radius
			local pushr = bo*xscale
			local pushl = bo*xscale
			if x <= -center+pushr or x >= center-pushl or y <= -center+pushr or y >= center-pushl then
				size = $/2
				x = max(pushr-center,min($,center-pushl))
				y = max(pushr-center,min($,center-pushl))
			end
			v.drawFill(xpos+x+center-size/2,ypos+y+center-size/2,size,size,color|V_NOSCALESTART)
		end
	end
	//Draw self coordinates
	v.drawFill(xpos+center-xscale/2,ypos+center-yscale/2,xscale,yscale,c_white|V_NOSCALESTART)
end
hud.add(hudstuff, player)

hud.add(function(v, player)
	if not (player.mindfuckery) return end
	if player.mo and player.mo.valid
		v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("STATIC"+tostring((leveltime%8)/2)),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK|V_80TRANS)
	end
end, "game")