//v4.1 changelog

/*- CSS art in-game change
- Removed Exetior & Legacy
- The shop now removes the total souls for a purchase
- Transformation sprites are in
- Super is now implemented
- Unique super theme
- Tweak in Metal Sonic Race
- You can't glitch anymore in Nights
- Breaking floors doesn't break now
- Tweaked Jumpthok
- Spindash cost reduced to ease the pain
- Upped the price of Tails Doll to 40
- Killermode fov can be disabled with exe_killerfov
- Shop transitions can be disabled with exe_instantshop
- Battlemod support
- Fixed Exetior having being stuck in dropdash sprites
- The entire game now has different skies and weathers
- Legacy can't shoot in ringslinger
- Minor fixes*/

//v4.1.1 changelog

/*- Fixed bug where THZ and ACZ1 would just go instantly dark
- Fixed Fov bug
- Fixed Super*/

//v4.1.2 changelog

/*- Killer mode deactivated when super
- Weapon next and previous can be replaced for custom 1 and 3
- Super ghost colors and such became red
- Legacy for ringslinger doesn't spawn fire
- Legacy now has battlemod support for firing arrows at the cost of 2 rings*/

freeslot("sfx_deadwf", "sfx_awfuck", "S_PLAY_EXERUN", "SFX_BJUMP", "SPR_MAX_", "SPR_EXEF", "S_PLAY_EXEFLT", "SFX_FLCKD", "SFX_RNGEXE", "SKINCOLOR_NOCTURNAL", "SKINCOLOR_ZOMBIE", "S_GIB", "MT_GIBEXE", "SPR_EXED", "S_EXEPUSHED")

local cv_slowmusic = CV_RegisterVar({"exe_slowmusic", "On", CV_NETVAR, CV_OnOff})
local cv_infsouls = CV_RegisterVar({"exe_infinitesouls", "Off", CV_NETVAR, CV_OnOff})
local cv_sharedsouls = CV_RegisterVar({"exe_sharedsouls", "On", CV_NETVAR, CV_OnOff})
local cv_canfov = CV_RegisterVar({"exe_killerfov", "On", CV_NETVAR, CV_OnOff})
local cv_exefinish = CV_RegisterVar({"exe_mustkill", "On", CV_NETVAR, CV_OnOff})
local cv_exelegacy = CV_RegisterVar({"exe_banlegacy", "Off", CV_NETVAR, CV_OnOff})

rawset(_G, "exetior", "multiplayer")
sfxinfo[sfx_flckd].caption = "Bloody explosion"
sfxinfo[sfx_rngexe].caption = "Activation"
sfxinfo[sfx_bjump].caption = "Double Jump"

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "why" and (cv_exelegacy.value))
		CONS_Printf(player, "You cannot play as Legacy EXE as the operators have disabled it.")
		S_StartSound(nil, sfx_lose, player)
		R_SetPlayerSkin(player, "sonic")
	end
end)

local enemylist = {
	MT_BLUECRAWLA,
	MT_REDCRAWLA,
	MT_GFZFISH,
	MT_GOLDBUZZ,
	MT_REDBUZZ,
	MT_JETTBOMBER,
	MT_JETTGUNNER,
	MT_CRAWLACOMMANDER,
	MT_DETON,
	MT_SKIM,
	MT_TURRET,
	MT_POPUPTURRET,
	MT_SPINCUSHION,
	MT_CRUSHSTACEAN,
	MT_BANPYURA,
	MT_BANPSPRING,
	MT_JETJAW,
	MT_SNAILER,
	MT_VULTURE,
	MT_POINTY,
	MT_ROBOHOOD,
	MT_FACESTABBER,
	MT_EGGGUARD,
	MT_GSNAPPER,
	MT_MINUS,
	MT_SPRINGSHELL,
	MT_YELLOWSHELL,
	MT_UNIDUS,
	MT_CANARIVORE,
	MT_PYREFLY,
	MT_PTERABYTE,
	MT_DRAGONBOMBER,
	MT_PENGUINATOR,
	MT_POPHAT,
	MT_HIVEELEMENTAL,
	MT_BUMBLEBORE,
	MT_SPINBOBERT,
	MT_HANGSTER
}

sfxinfo[sfx_rngexe].caption = "Sparkle"
sfxinfo[sfx_flckd].caption = "Splatter"
states[S_GIB] = {SPR_LIQD, A, -1, nil, 0, 0, S_GIB}

states[S_EXEPUSHED].sprite = SPR_EXED
states[S_EXEPUSHED].frame = A
states[S_EXEPUSHED].tics = 20
states[S_EXEPUSHED].nextstate = S_PLAY_STND

mobjinfo[MT_GIBEXE] = {
	doomednum = 2000,
	spawnstate = S_GIB,
	spawnhealth = 1000,
    deathstate = S_NULL,
    speed = 10*FRACUNIT,
    radius = 12*FRACUNIT,
    height = 14*FRACUNIT
}

states[S_PLAY_EXERUN].sprite = SPR_MAX_
states[S_PLAY_EXERUN].frame = A
states[S_PLAY_EXERUN].tics = 2
states[S_PLAY_EXERUN].nextstate = S_PLAY_WALK
states[S_PLAY_EXEFLT].sprite = SPR_EXEF
states[S_PLAY_EXEFLT].frame = A
states[S_PLAY_EXEFLT].tics = 3
states[S_PLAY_EXEFLT].nextstate = S_PLAY_WALK

skincolors[SKINCOLOR_NOCTURNAL] = {
    name = "Nocturnal",
    ramp = {146,150,153,155,156,157,158,159,253,253,253,253,254,254,30,31},//{146,150,153,154,156,157,168,169,169,169,253,254,254,254,30,31},{149,150,150,155,156,156,157,158,158,159,253,253,254,254,30,3},
    invcolor = SKINCOLOR_ORANGE,
    invshade = 7,
    chatcolor = V_BLUEMAP,
    accessible = true
}

skincolors[SKINCOLOR_ZOMBIE] = {
    name = "Zombie",
    ramp = {129,141,143,138,138,138,139,139,253,253,254,254,254,30,31,31},//{129,140,142,143,143,143,138,138,138,138,158,158,159,253,254,31},
    invcolor = SKINCOLOR_FLAME,
    invshade = 7,
    chatcolor = V_BLUEMAP,
    accessible = true
}

local function ableTo(player)
	if (player.mo and player.mo.valid)
	and (player.mo.skin == "exetior")
	and (player.powers[pw_carry] == CR_NONE)
	and (player.playerstate == PST_LIVE)
	and not (player.pflags & PF_FINISHED)
	and not (player.exiting)
		return true
	else
		return false
	end
end

addHook("MapLoad", function(map)
	if (server == nil) return end
	if not multiplayer
		if (mapheaderinfo[gamemap].bonustype == 1)
		or (mapheaderinfo[gamemap].race)
			server.countmany = 0
			server.enemytotal = 0
			server.perfected = 0
			server.countleft = 0
		end
		return
	end
	server.countmany = 0
	server.enemytotal = 0
	server.countleft = 0
	server.perfected = 0
end)

local function enemyDeath(mobj, inflictor, source)
	server.countleft = $ + 1

	S_StartSound(mobj.target, sfx_flckd)
	A_Create_Liquid(mobj, 1, 6, SKINCOLOR_RED, 4)
	A_Create_Liquid(mobj, 1, 10, SKINCOLOR_RED, 10)
	A_Create_Liquid(mobj, 3, 6, SKINCOLOR_BLACK, 14)
	local gib = A_Create_Gibs(mobj,4,0,8, SKINCOLOR_RED)
	local random = P_RandomRange(0,1)
	if (random == 1)
		if not gib return end
		gib.frame = 1
	end
	if (source == nil) return end
	if not (source.player) return end
	if (cv_sharedsouls.value)
		for player in players.iterate
			if not (player.souls)
				player.souls = 1
			else
				player.souls = $ + 1
			end
		end
	else
		if not (source.player.souls)
			source.player.souls = 1
		else
			source.player.souls = $ + 1
		end
	end
	if not (source.player.exehealth) return end
	if (source.player.exehealth < 81)
	and not G_RingSlingerGametype()
	and (source.player.powers[pw_carry] ~= CR_NIGHTSMODE)
	and (source.player.powers[pw_carry] ~= CR_NIGHTSFALL)
	and not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
		source.player.exehealth = $ + 5
	elseif (source.player.exehealth >= 82)
	and not G_RingSlingerGametype()
	and (source.player.powers[pw_carry] ~= CR_NIGHTSMODE)
	and (source.player.powers[pw_carry] ~= CR_NIGHTSFALL)
	and not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
		source.player.exehealth = 85
	end
end

local function enemyCounter(mobj)
	if (mobj.valid) and (leveltime == 0) and (mobj.counted == nil)
		server.countmany = 0
		server.countleft = 0
		server.enemytotal = 0
		server.perfected = 0
		mobj.counted = true
	end
	if (leveltime == 1)
		if (mobj.valid) and (mobj.counted == true)
			if (server.countmany == nil)
				server.countmany = 0
			end
			if (server.countleft == nil)
				server.countleft = 0
			end
			server.countmany = $ + 1
			server.enemytotal = $ + 1
		end
	end
end

for _,k in ipairs(enemylist) do
  addHook("MobjThinker", enemyCounter, k)
  addHook("MobjDeath", enemyDeath, k)
end

addHook("ShouldDamage", function(mo, i, s, d, dt)
    if (mo.valid) and (mo.player) and (mo.skin == "exetior") and not G_RingSlingerGametype() and not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
		if not (dt)
			if (mo.player.rings == 0) and not (mo.player.powers[pw_flashing])
				if (mo.player.lives <= 1)
					return true
				else
					mo.player.lives = $ - 1
					mo.player.powers[pw_flashing] = TICRATE
					mo.player.stun = TICRATE/4
					S_StartSound(mo, sfx_altow1)
					return false
				end
			end
		end
		if (dt == DMG_CRUSHED)
			mo.player.crushed = 2
			if (mo.player.lives <= 1)
				return true
			else
				return false
			end
		elseif (dt == DMG_DEATHPIT) 
		and (mo.player.rings == 0)
			if (mo.player.lives <= 1)
				return true
			else
				if not (mo.player.starpostnum)
					P_TeleportMove(mo, mo.startx, mo.starty, mo.startz)
				else
					P_TeleportMove(mo, mo.player.starpostx, mo.player.starposty, mo.player.starpostz)
					mo.angle = mo.player.starpostangle
				end
				mo.player.lives = $ - 1
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				mo.player.powers[pw_flashing] = TICRATE
				mo.player.stun = TICRATE/2
				S_StartSound(mo, sfx_s3k92, player)
				return false
			end
		end
	end
end, MT_PLAYER)

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid)
		player.exeperfect = $ or 0
		player.exeprfect = $ or 0
		if (player.exeperfect ~= 0)
			player.exeperfect = $ + player.exeprfect
			if (player.exeperfect < 100)
			and (leveltime % 2 == 0)
				player.exeprfect = $ - 1
			elseif (player.s3s > 100)
			and (leveltime % 2 == 0)
				player.exeprfect = $ + 1
			end
			if (player.exeperfect >= 200)
				player.exeperfect = 0
			end
		end
		if not (player.mo.startx)
			player.mo.startx = player.mo.x
		end
		if not (player.mo.starty)
			player.mo.starty = player.mo.y
		end
		if not (player.mo.startz)
			player.mo.startz = player.mo.z
		end
	end
	if (player.mo and player.mo.valid and player.mo.skin == "exetior")
		player.stun = $ or 0
		player.souls = $ or 0
		player.exehealth = $ or 0
		player.s3s = $ or 0
		player.tailsdoll = $ or 0
		player.jumpthok = $ or 0
		player.spindash = $ or 0
		player.radar = $ or 0
		player.s3ss = $ or 0
		player.spenbutton = $ or 0
		player.selected = $ or 0
		if (S_SoundPlaying(player.mo, sfx_awfuck))
			S_StopSound(player.mo)
			S_StartSound(player.mo, sfx_deadwf)
		end
		if ((player.mo.state == S_PLAY_RUN) or (player.mo.state == S_PLAY_EXERUN))
		and not (player.powers[pw_super])
		and not (gametype == GT_EXESURVIVAL)
			if (player.speed >= 40*FRACUNIT)
			and not (player.powers[pw_sneakers])
				player.mo.state = S_PLAY_EXERUN
			elseif (player.speed >= 60*FRACUNIT)
			and (player.powers[pw_sneakers])
				player.mo.state = S_PLAY_EXERUN
			end
		elseif ((player.mo.state == S_PLAY_WALK) or (player.mo.state == S_PLAY_EXEFLT))
		and not (player.powers[pw_super])
		and ((player.speed > 0) and (player.speed < 3*FRACUNIT))
		and not (gametype == GT_EXESURVIVAL)
			player.mo.state = S_PLAY_EXEFLT
			player.mo.frame = 0
			player.mo.sprite = SPR_EXEF
		end
		if (cv_infsouls.value)
			player.souls = 999
		end
		if (player.weapondelay > 0)
			player.weapondelay = $ - 2
		else
			player.weapondelay = 0
		end
		if (player.jumpthok == 1)
			player.charability = CA_JUMPTHOK
		else
			player.charability = CA_DOUBLEJUMP
		end
		if (player.s3s ~= 0)
			player.s3s = $ + player.s3ss
			if (player.s3s < 100)
			and (leveltime % 2 == 0)
				player.s3ss = $ - 1
			elseif (player.s3s > 100)
			and (leveltime % 2 == 0)
				player.s3ss = $ + 1
			end
			if (player.s3s >= 200)
				player.s3s = 0
			end
		end
		if (CBW_Battle)
		or (gametype == GT_EXESURVIVAL)
			player.selected = 2
		end
		if (player.selected == 2)
		and (player.spindash == 1)
			if (player.speed < 5*FRACUNIT)
				player.charability2 = CA2_SPINDASH
			else
				if (player.isxmomentum == nil)
					player.charability2 = CA2_NONE
				else
					player.charability2 = CA2_SPINDASH
				end
			end
		else
			player.charability2 = CA2_NONE
		end
		if (player.pflags & PF_SPINNING)
		and (player.spenbutton == 0)
		and (player.cmd.buttons & BT_USE)
		and (ableTo(player))
		and (player.selected == 2)
		and (player.speed >= 5*FRACUNIT)
		and (player.spindash == 1)
		and (player.isxmomentum == nil)
		and P_IsObjectOnGround(player.mo)
			player.spenbutton = 1
			player.mo.state = S_PLAY_WALK
			player.pflags = $1 & ~PF_SPINNING
		elseif (player.spenbutton == 0)
		and (player.cmd.buttons & BT_USE)
		and not (player.pflags & PF_SPINNING)
		and (player.speed >= 5*FRACUNIT)
		and (ableTo(player))
		and (player.selected == 2)
		and (player.spindash == 1)
		and (player.isxmomentum == nil)
		and P_IsObjectOnGround(player.mo)
			player.spenbutton = 1
			player.mo.state = S_PLAY_ROLL
			player.pflags = $1|PF_SPINNING
			S_StartSound(player.mo, sfx_spin)
		elseif (player.spenbutton == 1)
		and not (player.cmd.buttons & BT_USE)
			player.spenbutton = 0
		end
		if (player.stun ~= 0)
			player.mo.state = S_EXEPUSHED
			player.stun = $ - 1
			player.powers[pw_nocontrol] = 2
		end
		if (player.mo.state == S_EXEPUSHED)
			player.powers[pw_nocontrol] = 2
		end
		if (leveltime == 0)
			player.insane = false
			player.exehealth = 0
		end
		if not (player.insane)
			player.insane = false
		end
		if (leveltime == 0)
			player.exehealth = 0
		end
		if (leveltime % 175 == 0)
		and (player.exehealth ~= 0)
		and (player.exehealth ~= 85)
		and (player.insane == false)
			player.exehealth = $ - 1
		end
		if (player.insane == true)
			player.powers[pw_sneakers] = 1
		end
		if (player.exehealth == 85)
		and (player.cmd.buttons & BT_CUSTOM2)
		and (player.insane == false)
		and not (player.powers[pw_super])
			COM_BufInsertText(player, "tunes exechs")
			player.insane = true
			P_SpawnGhostMobj(player.mo)
			S_StartSound(nil, sfx_rngexe, player)
		end
		if G_RingSlingerGametype()
		or (CBW_Battle)
		or (gametype == GT_EXESURVIVAL)
			player.insane = false
			player.exehealth = 0
			player.radar = 0
			player.tailsdoll = 0
			player.spindash = 1
			player.jumpthok = 1
		end
		if (player.insane == true)
			if (leveltime % 10 == 0)
				player.exehealth = $ - 1
			end
			if (player.exehealth == 0)
				player.insane = false
				COM_BufInsertText(player, "tunes -default")
			end
		end
		if (player.powers[pw_carry] ~= CR_NIGHTSMODE)
		and (player.powers[pw_carry] ~= CR_NIGHTSFALL)
		and not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
		and (player.mo.sprite2 == SPR2_TRNS)
			S_ChangeMusic("exespr", true, player)
		end
		if (player.insane == true)
		and (player.powers[pw_super])
			player.insane = false
			S_ChangeMusic("exespr", true, player)
		end
		if (player.insane == false)
			if (player.exehealth >= 35 and player.exehealth <= 85)
			and (cv_slowmusic.value)
			and not (player.powers[pw_super])
			and (player.powers[pw_carry] ~= CR_NIGHTSMODE)
			and (player.powers[pw_carry] ~= CR_NIGHTSFALL)
			and not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
			and (mapheaderinfo[gamemap].bonustype ~= 1)
			and not (mapheaderinfo[gamemap].race)
			and not (player.powers[pw_sneakers])
			and not (player.powers[pw_invulnerability])
			and (player.shop ~= true)
				S_SetMusicPosition(S_GetMusicPosition()-(player.exehealth-35))
			end
			if not (cv_canfov.value)
				COM_BufInsertText(player, "fov 90")
			end
			if (cv_canfov.value)
				if CV_FindVar("fov").value > 90*FRACUNIT
					COM_BufInsertText(player, "add fov -1")
				elseif CV_FindVar("fov").value < 90*FRACUNIT
					COM_BufInsertText(player, "add fov 1")
				end
			end
		elseif (player.insane == true)
			if (player.shop == false)
			and not (player.powers[pw_invulnerability])
				if (leveltime % 70 == 0)
					COM_BufInsertText(player, "fov 50")
				end
				if (cv_canfov.value)
					if CV_FindVar("fov").value > 80*FRACUNIT
						COM_BufInsertText(player, "add fov -1")
					elseif CV_FindVar("fov").value < 80*FRACUNIT
						COM_BufInsertText(player, "add fov 1")
					end
				end
			end
		end
		if (player.powers[pw_sneakers])
			player.runspeed = 3*FRACUNIT
		else
			player.runspeed = skins[player.mo.skin].runspeed
		end
		player.crushed = $ or 0
		if (player.crushed > 0)
			if (player.crushed == 1)
				if (player.lives > 1)
					player.lives = $ - 1
				end
			end
			player.crushed = $ - 1
		end
	end
end)

addHook("TouchSpecial", function(checkpoint, mo)
	if (mo.player.starpostnum < checkpoint.health)
		if (cv_sharedsouls.value)
			for p in players.iterate
				if not (p.souls)
					p.souls = 3
				else
					p.souls = $ + 3
				end
				p.s3s = 1
				p.s3ss = 10
				S_StartSound(nil, sfx_s3kb0, p)
			end
		else
			if not (mo.player.souls)
				mo.player.souls = 3
			else
				mo.player.souls = $ + 3
			end
			mo.player.s3s = 1
			mo.player.s3ss = 10
			S_StartSound(nil, sfx_s3kb0, mo.player)
		end
	end
end, MT_STARPOST)

addHook("MobjThinker", function(ring)
	if not (ring.target) return end
	if (ring.valid) and (ring.target.skin == "exetior")
		ring.color = SKINCOLOR_RED
		if (ring.sprite ~= SPR_TRNG)
			if (ring.sprite == SPR_SPRK)
				ring.colorized = true
				return
			else
				ring.sprite = SPR_TRNG
			end
		end
	end
end, MT_FLINGRING)

addHook("MobjSpawn", function(flicky)
	if ((flicky.type == MT_FLICKY_01)
	or (flicky.type == MT_FLICKY_02)
	or (flicky.type == MT_FLICKY_03)
	or (flicky.type == MT_FLICKY_04)
	or (flicky.type == MT_FLICKY_05)
	or (flicky.type == MT_FLICKY_06)
	or (flicky.type == MT_FLICKY_07)
	or (flicky.type == MT_FLICKY_08)
	or (flicky.type == MT_FLICKY_09)
	or (flicky.type == MT_FLICKY_10)
	or (flicky.type == MT_FLICKY_11)
	or (flicky.type == MT_FLICKY_12)
	or (flicky.type == MT_FLICKY_13)
	or (flicky.type == MT_FLICKY_14)
	or (flicky.type == MT_FLICKY_15)
	or (flicky.type == MT_FLICKY_16))
		local player = P_LookForPlayers(flicky, 512*FRACUNIT, true)
		if (flicky.target == nil) return end
		if (flicky.target.valid) and (flicky.target.skin == "exetior")
			P_TeleportMove(flicky, flicky.x+16384*FRACUNIT, flicky.y+16384*FRACUNIT, flicky.z)
			flicky.flags2 = $1 & MF2_DONTDRAW
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if (player.mo.skin ~= "exetior") return end
	if (player.pflags & PF_THOKKED) return end
	local ghost = P_SpawnGhostMobj(player.mo)
	ghost.colorized = true
	ghost.color = SKINCOLOR_BLACK
	ghost.scale = $ + $/4
	if (player.charability == CA_DOUBLEJUMP)
		S_StartSound(player.mo, sfx_bjump)
	else
		S_StartSound(player.mo, sfx_thok)
		P_InstaThrust(player.mo, player.mo.angle, player.speed+player.speed/16)
	end
	player.pflags = $1|PF_THOKKED
	if (player.mo.momz >= 0)
		player.mo.momz = $1/2+10*FRACUNIT*P_MobjFlip(player.mo)
	else
		player.mo.momz = 10*FRACUNIT*P_MobjFlip(player.mo)
	end
	for i = 1, 8
		local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z + (player.mo.eflags & MFE_VERTICALFLIP and 4*player.mo.scale or 0), player.mo.eflags & (MFE_UNDERWATER | MFE_TOUCHWATER) and MT_MEDIUMBUBBLE or MT_PARTICLE)
		dust.fuse = TICRATE/2
		dust.scale = player.mo.scale
		dust.destscale = player.mo.scale/8
		P_InstaThrust(dust, i*ANGLE_45, 4*player.mo.scale)
		dust.momz = -2*FRACUNIT*P_MobjFlip(player.mo)
		dust.frame = $1|TR_TRANS60
	end
	return true
end)

addHook("MobjThinker", function(ring)
	if (ring.valid)
		local target = P_LookForPlayers(ring, 384*FRACUNIT, true)
		if (target == true) and (ring.target.skin == "exetior") and (ring.color ~= SKINCOLOR_RED)
			P_SpawnGhostMobj(ring)
			ring.deathsound = sfx_rngexe
			ring.color = SKINCOLOR_RED
		end
		if (ring.color == SKINCOLOR_RED) and (ring.sprite ~= SPR_TRNG)
			if (ring.sprite == SPR_SPRK)
				ring.colorized = true
				return
			else
				ring.sprite = SPR_TRNG
			end
		end
	end
end, MT_RING)

addHook("MobjDeath", function(ring)
	if not ring.target return end
	if (ring.target.valid) and (ring.target.player) and (ring.target.skin == "exetior") and not G_RingSlingerGametype()
		if (ring.target.player.exehealth < 85)
			ring.target.player.exehealth = $ + 1
		else
			ring.target.player.exehealth = 85
		end
	end
end, MT_RING)

addHook('ThinkFrame', do
	for player in players.iterate do
		if player.mo and player.mo.scale and player.mo.friction and player.mo.movefactor then
			local pmo = player.mo
			if pmo.skin ~= "exetior" return end
			//Create history
			if player.waterlast == nil then
				player.waterlast = false
				player.dashlast = false
				player.realfriction = pmo.friction
			end
			local skin = skins[pmo.skin]
			
			local water = 1+(pmo.eflags&MFE_UNDERWATER)/MFE_UNDERWATER //Water factor for momentum halving
			local grounded = P_IsObjectOnGround(pmo)
			local nmom = skin.normalspeed //Skin normalspeed, the integral component
			//Dashmode overrides skin normalspeed
			if player.dashmode >= 3*TICRATE then
				nmom = player.normalspeed
			end
			
			local scale = pmo.scale //Normalspeed calculations are affected by scale
			local friction = FixedDiv(pmo.friction,pmo.movefactor) //Reversing friction is required for sustaining ground momentum
			local pmom = FixedDiv(FixedHypot(player.rmomx,player.rmomy),scale) //Current speed, scaled for normalspeed calculations
			local pwup = (player.powers[pw_sneakers]) or (player.powers[pw_super]) //Speed-ups multiply max allowed speed by 5/3
			local momangle = R_PointToAngle2(0,0,player.rmomx,player.rmomy) //Used for angling new momentum in ability cases
			//Adjust current speed reading for calculations with pwup status
			if pwup then
				pmom = $*3/5
			end
			local mom = FixedHypot(pmo.momx,pmo.momy)		
			
			/////////
			//General momentum scaling
			
			//Do landing momentum cut
			if pmo.eflags&MFE_JUSTHITFLOOR then
				player.normalspeed = skin.normalspeed
				pmo.friction = $-$/10
			//Do ground momentum
			elseif grounded then
				//The amount of momentum to sustain
				local sustain = FixedDiv(min(pmom*water,nmom*2),friction)
-- 				if pmom > player.normalspeed then
					player.normalspeed = max(nmom,sustain)
-- 				end
			//Do air momentum
			elseif not(player.dashmode) then //Dashmode overrides normalspeed in the air
				player.normalspeed = skin.normalspeed
			end
			
			//Update history
			player.waterlast = (pmo.eflags&MFE_UNDERWATER > 0)
			player.dashlast = (player.pflags&PF_STARTDASH > 0)
		end
	end
end)

addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid
		p.pressedbutton = $ or 0
		if not p.canpress
			p.canpress = true
		end
		if (p.pressedbutton ~= 0)	
			p.pressedbutton = $ - 1
			p.canpress = false
		else
			p.canpress = true
		end
		if p.mo.skin == "exetior"
		and p.pflags & PF_FINISHED
		and cv_exefinish.value
		and server.countleft < server.countmany/3
			p.exiting = 0
			p.pflags = $1 & ~PF_FINISHED
			S_StartSound(nil,sfx_lose,p)
			local angle = R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x + p.mo.momx, p.mo.y + p.mo.momy) + ANGLE_180
			P_InstaThrust(p.mo,angle, 80*FRACUNIT)
			p.mo.momz = -$
			p.drawangle = angle
			p.mo.state = S_PLAY_PAIN
		end
    end
end)

addHook("ShouldDamage", function(target, inflictor)
	if (target.valid) and (target.player) and (target.player.insane)
	and (inflictor.valid) and (inflictor.flags & MF_ENEMY)
		P_KillMobj(inflictor, target, target)
		return false
	end
end, MT_PLAYER)

hud.add(function(v, player)
	if not (player.mo) return end
	if player.mo and player.mo.skin ~= "exetior" return end
	local name = "EXETIOR"
	/*local 320 = (v.320() / v.dupx())
	local 200 = (v.200() / v.dupy())*/
	local thin = "thin"
	local xoff = 0
	if (player.mo.color == SKINCOLOR_ZOMBIE)
		name = "SARK"
		thin = "left"
		xoff = 1
	end
	if G_RingSlingerGametype() return end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) return end
	if (player.powers[pw_carry] == CR_NIGHTSFALL) return end
	v.drawString(40+xoff,176,name,V_MONOSPACE|V_REDMAP|V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, thin)
	if (CBW_Battle) return end
	if (gametype == GT_EXESURVIVAL) return end
	if (player.s3s)
		v.drawString(160,player.s3s,"+3 souls",0,"center")
	end
	if (player.exeperfect)
		v.drawString(160,player.exeperfect-4,"PERFECT",V_REDMAP,"center")
		v.drawString(160,player.exeperfect+4,"SOULS HAVE BEEN MULTIPLIED BY 2",V_REDMAP,"thin-center")
	end
	if (player.insane == false)
	and (player.exehealth == 85)
	and not (player.powers[pw_super])
		v.drawString(26,80,"Killer Mode",V_MONOSPACE|V_REDMAP|V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT, "thin")
		v.drawScaled(5*FRACUNIT,75*FRACUNIT,FRACUNIT,v.cachePatch("CUSTOM1"),V_SNAPTOLEFT|V_SNAPTOTOP)
	end
	v.drawString(28,55,"Insanity Meter",V_MONOSPACE|V_INVERTMAP|V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT, "thin")
	v.drawScaled(5*FRACUNIT,55*FRACUNIT,FRACUNIT/2,v.cachePatch("BAR1"),V_SNAPTOLEFT|V_SNAPTOTOP)
	if (player.exehealth ~= nil)
		local bar
		if (player.powers[pw_super])
			bar = 85
		else
			bar = player.exehealth
		end
		for i = 0,bar
			v.drawStretched((25+i/2)*FRACUNIT, 65*FRACUNIT, FRACUNIT/2, FRACUNIT-FRACUNIT/4, v.cachePatch("BAR2"),V_SNAPTOLEFT|V_SNAPTOTOP)
		end
	end
	v.drawScaled(320*((v.width()/v.dupx())/320)*FRACUNIT,0, FRACUNIT, v.cachePatch("SOULSHP"),V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_MONOSPACE)
	if (server.countmany == nil) return end
	if (server.countleft == nil) return end
	local flags = V_MONOSPACE|V_PERPLAYER
	local how = "left"
	if string.len(tostring(server.countleft)+"/"+tostring(server.countmany)) > 4
		how = "thin"
	end
	if (server.countleft >= server.countmany/3)
		flags = $1|V_REDMAP
	end
	local yoff = 15
	if (mapheaderinfo[gamemap].bonustype ~= 1)
	and not (mapheaderinfo[gamemap].race)
		yoff = 60
		v.draw(320-(v.width()/v.dupx()/320),200-(v.height()/v.dupy()/200),v.cachePatch("KILLCNT"),V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_PERPLAYER|V_MONOSPACE)
		v.drawString(320-45,200-25,tostring(server.countleft)+"/"+tostring(server.countmany),flags|V_SNAPTORIGHT|V_SNAPTOBOTTOM,how)
		if (cv_exefinish.value)
			v.drawString(320-50,200-50,"Needed: "+tostring(server.enemytotal/3),V_REDMAP|V_SNAPTORIGHT|V_SNAPTOBOTTOM,"thin")
		end
	end
	v.drawString(320-5,200-yoff,"Souls: "+tostring(player.souls),V_30TRANS|V_SNAPTOBOTTOM|V_SNAPTORIGHT,"thin-right")
end)