freeslot("sfx_knftr2", "sfx_knftrw", "sfx_knfbng", "MT_EXEKNIFE", "SFX_STATIC", "S_EXEKNIFE", "SPR_KNFE", "SPR_DRPD", "SFX_DRPDSH")

local cv_nostatic = CV_RegisterVar({"exe_nostatic", "Off", CV_NETVAR, CV_OnOff})
local cv_instashop = CV_RegisterVar({"exe_instantshop", "Off", CV_NETVAR, CV_OnOff})

sfxinfo[sfx_drpdsh] = {
	singular = false,
	caption = "Drop Dash"
}

hudinfo[HUD_POWERUPS].y = 120

sfxinfo[sfx_knftrw].caption = "Whoosh"
sfxinfo[sfx_knftr2].caption = "Whoosh"
sfxinfo[sfx_knfbng].caption = "Knife collision"

sfxinfo[sfx_static].caption = "Static"

mobjinfo[MT_EXEKNIFE] = {
	spawnstate = S_EXEKNIFE,
	spawnhealth = 1000,
    deathstate = S_NULL,
    speed = 10*FRACUNIT,
    radius = 20*FRACUNIT,
    height = 16*FRACUNIT,
	flags = MF_NOGRAVITY
}

states[S_EXEKNIFE].sprite = SPR_KNFE
states[S_EXEKNIFE].frame = A
states[S_EXEKNIFE].tics = 350
states[S_EXEKNIFE].nextstate = S_NULL


//DO
//Resolution support
//Remove color fading
//Add "border" objects
//radar size varies with gametype

local test = 0
-- local radar_enabled = true
/*COM_AddCommand("radar",function(player)
	radar_enabled = not(radar_enabled)
	if radar_enabled then print("Object radar enabled.")
	else print("Object radar disabled.")
	end
end,1)
*/

//Colors
local c_white = 0
local c_silver = 6
local c_black = 31
local c_blue = 149
local c_darkblue = 154
local c_red = 34
local c_darkred = 40
local c_yellow = 72
local c_orange = 56
local c_green = 102
local c_purple = 180
local c_darkpurple = 184
local c_border = 27 //Color for radar borders
local color = c_white //Currently selected color
local bo = 2 //border offset

local function hudstuff(v, user, cam)
	local umo = user.mo
	if umo == nil 
		or (user.pflags&PF_TAGIT and leveltime < 30*TICRATE)
		then return
	end	
	if (user.radar ~= 1) return end
-- 	local test = user.rings
	//Setup radar
	local xscale = v.dupx()
	local yscale = v.dupx()
-- 	local unit = user.mo.scale
	local unit = FRACUNIT
	local radius = 64*12
	local fullsight = 64*32
	local radarsize = 48*xscale
	local hradius = radius
	if splitscreen then radarsize = $*2/3 end
	local center = radarsize/2
	
	//Alignment
-- 	local xpos = 8 //Left corner
-- 	local xpos = v.width()/v.dupx()-radarsize-16 //Right corner
	local xpos = v.width()-radarsize-8*xscale //Right corner
	local ypos = 84*yscale //Top corner
-- 	local ypos = 8 //Top corner
-- 	local ypos = v.height()/yscale-radarsize-32 //Bottom corner
	if splitscreen then //2-Player offsets
		ypos = $/2
		if user == secondarydisplayplayer then
			ypos = $+v.height()/2
		end
	end
	local xpos2 = xpos+radarsize-xscale
	local ypos2 = ypos+radarsize-yscale
	//Draw radar box
-- 	v.drawFill(xpos,ypos,radarsize,radarsize,c_black)
	v.drawFill(xpos,ypos,radarsize,radarsize,c_black|V_NOSCALESTART)
	//Draw borders
	v.drawFill(xpos+xscale,ypos+yscale,radarsize-xscale*2,yscale,c_border|V_NOSCALESTART) //Top border
	v.drawFill(xpos+xscale,ypos2-yscale,radarsize-xscale*2,yscale,c_border|V_NOSCALESTART) //Bottom border
	v.drawFill(xpos+xscale,ypos+yscale,xscale,radarsize-yscale*2,c_border|V_NOSCALESTART) //Left border
	v.drawFill(xpos2-xscale,ypos+yscale,xscale,radarsize-yscale*2,c_border|V_NOSCALESTART) //Right border
	
	if (user.radar == 1)
	//Search mobj and draw coordinates
		searchBlockmap("objects",function (umo,mo)
			if mo == nil or not(mo.health) then return nil end 
			local dist = R_PointToDist2(umo.x,umo.y,mo.x,mo.y)
			local zdist = abs(mo.z-umo.z)
			local flash1 = not(leveltime&15)
			local flash2 = not(leveltime&4)
			local size = xscale*2
			if splitscreen then 
				size = $*2/3
			end
			//Distance check
			if dist > fullsight*unit then return nil
			//Players
			elseif mo.type == MT_PLAYER then
				color = c_yellow
			//Badniks and bosses
			elseif mo.flags&MF_ENEMY
				then color = c_darkred
			elseif mo.flags&MF_BOSS
				then
				size = $*3/2
				color = c_darkred
			//Item pickups
	-- 		elseif (mo.flags&MF_MONITOR) and mo.health and not(mo.type == MT_RING_BOX) then color = c_green
			elseif (mo.type >= MT_BOUNCEPICKUP and mo.type <= MT_GRENADEPICKUP) then
				color = c_green
-- 				size = $*2/3
			elseif (mo.type == MT_TOKEN or (mo.type <= MT_EMERHUNT and mo.type >= MT_EMERALD1))
				if not(flash1) then color = c_orange
				else color = c_yellow
				end
-- 				size = $*2/3
			//Starpost
			elseif (mo.type == MT_STARPOST) then 
				if not(flash1) then color = c_purple
				else color = c_yellow
				end
			//Goalsign
			elseif (mo.type == MT_SIGN) then 
				if not(flash2) then color = c_purple
				else color = c_yellow
				end
			
			//CTF Flags
			elseif mo.type == MT_REDFLAG then
				if not(flash1) and not(mo.fuse and flash2) then
					color = c_darkred
				else 
					color = c_yellow
				end
-- 				size = $*2/3
			elseif mo.type == MT_BLUEFLAG then
				if not(flash1) and not(mo.fuse and flash2) then
					color = c_darkblue
				else
					color = c_yellow
				end
-- 				size = $*2/3
			else return nil
			end
	 		if zdist > hradius*unit then size = $*2/3 end
			local angle = umo.angle-R_PointToAngle2(umo.x,umo.y,mo.x,mo.y)+ANGLE_270
			local x = P_ReturnThrustX(nil,angle,dist)/unit*center/radius
			local y = P_ReturnThrustY(nil,angle,dist)/unit*center/radius
			local pushr = bo*xscale
			local pushl = bo*xscale
			if x <= -center+pushr or x >= center-pushl or y <= -center+pushr or y >= center-pushl then
				size = $/2
				x = max(pushr-center,min($,center-pushl))
				y = max(pushr-center,min($,center-pushl))
			end
			v.drawFill(xpos+x+center-size/2,ypos+y+center-size/2,size,size,color|V_NOSCALESTART)
	-- 		print(color)
			return nil
		end,umo,umo.x-fullsight*unit,umo.x+fullsight*unit,umo.y-fullsight*unit,umo.y+fullsight*unit)
	else
		for player in players.iterate
			local mo = player.mo
			if mo == nil or mo == umo or player.spectator or not(mo.health)
				then continue
			else color = c_blue
			end
			local size = xscale*2
			local dist = R_PointToDist2(umo.x,umo.y,mo.x,mo.y)
			local angle = umo.angle-R_PointToAngle2(umo.x,umo.y,mo.x,mo.y)+ANGLE_270
			local x = P_ReturnThrustX(nil,angle,dist)/unit*center/radius
			local y = P_ReturnThrustY(nil,angle,dist)/unit*center/radius
			local pushr = bo*xscale
			local pushl = bo*xscale
			if x <= -center+pushr or x >= center-pushl or y <= -center+pushr or y >= center-pushl then
				size = $/2
				x = max(pushr-center,min($,center-pushl))
				y = max(pushr-center,min($,center-pushl))
			end
			v.drawFill(xpos+x+center-size/2,ypos+y+center-size/2,size,size,color|V_NOSCALESTART)
		end
	end
	//Draw self coordinates
	v.drawFill(xpos+center-xscale/2,ypos+center-yscale/2,xscale,yscale,c_white|V_NOSCALESTART)
	v.drawScaled(xpos+center-xscale/2,ypos+center-yscale/2,FRACUNIT/4,v.cachePatch("EXELFE"),V_NOSCALESTART,v.getColormap(-1, user.mo.color))
end
hud.add(hudstuff, player)

addHook("MobjMoveCollide", function(knife, target)
	if (knife.valid) and (target.valid)
	and ((target.flags & MF_ENEMY) or (target.flags & MF_BOSS) or (target.flags & MF_MONITOR))
	and (knife.z > target.z) and (knife.z < target.z+target.height)
		P_DamageMobj(target, knife, knife.target)
		P_KillMobj(knife)
	end
end, MT_EXEKNIFE)

addHook("MobjThinker", function(knife)
	if (knife.valid) and (knife.momx == 0) and (knife.momy == 0) and not (knife.flags & MF_SOLID)
		knife.flags = $1|MF_SOLID
		knife.momz = 0
		S_StartSound(knife, sfx_knfbng)
	end
end, MT_EXEKNIFE)

/*addHook("ThinkFrame", do
	if not (server.countleft) return end
	if not (server.enemycount) return end
	if (server.countleft >= server.enemycount) and (server.perfected ~= 0)
		print("it works!")
		for p in players.iterate
			p.exeperfect = 1
			p.exeprfect = 0
			p.souls = $ + server.enemycount
		end
		server.perfected = 1
		S_StartSound(nil, sfx_s3kac)
	end
end)*/

addHook("PlayerThink", function(player)
	if (player.spectator) return end
	if (player.mo and player.mo.valid)
		if (player.spring == nil)
			player.spring = false
		end
		
		if P_IsObjectOnGround(player.mo)
		or (player.mo.eflags & MFE_JUSTHITFLOOR)
			player.spring = false
		end
		
		if (player.powers[pw_justsprung])
		and not P_IsObjectOnGround(player.mo)
			player.spring = true
		end
		
		if (player.mo and player.mo.valid)
		and (player.mo.skin == "exetior")
		and (player.powers[pw_carry] == CR_NONE)
		and (player.playerstate == PST_LIVE)
		and not (player.pflags & PF_FINISHED)
		and not (player.exiting)
		and not P_PlayerInPain(player)
		and (player.spring == true)
		and (player.isxmomentum == nil)
			if (player.mo.momz >= 2*FRACUNIT)
				player.mo.state = S_PLAY_SPRING
			elseif (player.mo.momz < 2*FRACUNIT) and (player.mo.momz >= -2*FRACUNIT)
				player.mo.state = S_PLAY_EXEFLT
			elseif (player.mo.momz < -2*FRACUNIT)
				player.mo.state = S_PLAY_FALL
			end
		end
	end
	
	if (player.mo and player.mo.valid and player.mo.skin == "exetior")
		if (player.shop == nil)
			player.shop = false
		end
		
		if (player.powers[pw_super])
			player.mo.color = player.skincolor
			local outline = P_SpawnGhostMobj(player.mo)
			outline.color = SKINCOLOR_CRIMSON
			outline.colorized = true
			outline.scale = player.mo.scale + FRACUNIT/7
			outline.fuse = 3
			outline.frame = player.mo.frame
			outline.momx = player.mo.momx
			outline.momy = player.mo.momy
			outline.momz = player.mo.momz
			P_TeleportMove(outline, player.mo.x, player.mo.y, player.mo.z-(player.mo.scale*8))
		end
		
		for x=player.mo.x,player.mo.x+player.mo.radius*2,player.mo.radius*2
			for y=player.mo.y,player.mo.y+player.mo.radius*2,player.mo.radius*2
				local ss = R_PointInSubsector(x,y)
				for fof in ss.sector.ffloors()
					if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
						if (player.mo.z+player.mo.momz==fof.topheight or player.mo.z+player.mo.height+player.mo.momz==fof.bottomheight or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz==fof.bottomheight or player.mo.z-player.mo.height-player.mo.momz==fof.topheight)))
						and (player.mo.eflags & MFE_JUSTHITFLOOR)
							EV_CrumbleChain(ss.sector, fof)
							S_StartSound(player.mo, sfx_drpdsh)
							S_StartSound(player.mo, sfx_s3k5f)
							player.mo.state = S_PLAY_ROLL
						end
					end
				end
			end
		end
			
		if (player.knifecount == nil)
			player.knifecount = 10
		end
		player.knifeshoot = $ or 0
		player.knifephase = $ or 0
		player.shopitem = $ or 0
		player.shoptimer = $ or 0
		player.shoptext = $ or 0
		player.pb = $ or 0
		player.pr = $ or 0
		player.pl = $ or 0
		player.pr2 = $ or 0
		player.pl2 = $ or 0
		/*player.pr3 = $ or 0
		player.pl3 = $ or 0*/
		player.selected = $ or 0
		player.strpost = $ or 0
		player.str = $ or 0
		player.strnum = $ or 0
		if (player.cmd.buttons & BT_CUSTOM2)
		and (player.strpost == 0)
			player.str = 0
			player.strnum = 0
		elseif (player.cmd.buttons & BT_CUSTOM2)
		and (player.strpost == TICRATE)
			player.strnum = 0
			player.str = 1
		end
		if (player.strpost < TICRATE)
		and (player.str == 0)
			player.strpost = $ + 1
		elseif (player.strpost > 0)
		and (player.str == 1)
			player.strpost = $ - 1
		end
		if ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.buttons & BT_CUSTOM3))
		and (player.pr2 == 0)
		and (player.shop == false)
			player.pr2 = 1
			if not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
				S_StartSound(nil, sfx_menu1, player)
			end
			if (player.selected == 2)
				player.selected = 0
			else
				player.selected = $ + 1
			end
		elseif ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.buttons & BT_CUSTOM1))
		and (player.pl2 == 0)
		and (player.shop == false)
			player.pl2 = 1
			if not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
				S_StartSound(nil, sfx_menu1, player)
			end
			if (player.selected == 0)
				player.selected = 2
			else
				player.selected = $ - 1
			end
		end
		if not (player.cmd.buttons & BT_WEAPONNEXT)
		and not (player.cmd.buttons & BT_CUSTOM3)
		and (player.pr2 == 1)
			player.pr2 = 0
		end
		if not (player.cmd.buttons & BT_WEAPONPREV)
		and not (player.cmd.buttons & BT_CUSTOM1)
		and (player.pl2 == 1)
			player.pl2 = 0
		end
		/*if ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.buttons & BT_CUSTOM3))
		and (player.pr3 == 0)
		and (player.strpost == TICRATE)
			player.pr3 = 1
			S_StartSound(nil, sfx_menu1, player)
			if (player.strnum == player.starpostnum)
				player.strnum = 0
			else
				player.strnum = $ + 1
			end
		elseif ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.buttons & BT_CUSTOM1))
		and (player.pl3 == 0)
		and (player.strpost == TICRATE)
			player.pl3 = 1
			S_StartSound(nil, sfx_menu1, player)
			if (player.strnum == 0)
				player.strnum = player.starpostnum
			else
				player.strnum = $ - 1
			end
		end
		if not (player.cmd.buttons & BT_WEAPONNEXT)
		and not (player.cmd.buttons & BT_CUSTOM3)
		and (player.pr3 == 1)
			player.pr3 = 0
		end
		if not (player.cmd.buttons & BT_WEAPONPREV)
		and not (player.cmd.buttons & BT_CUSTOM1)
		and (player.pl3 == 1)
			player.pl3 = 0
		end*/
		if (player.insane == true)
			S_StartSound(player.mo, sfx_static)
		else
			if S_SoundPlaying(player.mo, sfx_static)
				S_StopSound(player.mo)
			end
		end
		if (player.cmd.buttons & BT_USE)
		and (player.knifeshoot == 0)
		and (player.selected == 0)
		and not G_RingSlingerGametype()
		and (player.powers[pw_carry] ~= CR_NIGHTSMODE)
		and (player.powers[pw_carry] ~= CR_NIGHTSFALL)
		and not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
			player.knifeshoot = 1
			if (player.knifephase == 0)
				if not player.lockenemy
					local enemy = P_LookForEnemies(player, true, true)
					if not enemy 
						if (player.knifecount == 0)
						and not player.powers[pw_super]
							return
						elseif not player.powers[pw_super]
						and (player.knifecount > 0)
							player.knifecount = $ - 1
						end
						S_StartSound(player.mo, sfx_knftr2)
						local knife = P_SpawnMobj(player.mo.x+P_ReturnThrustX(player.mo, player.drawangle, 12*FRACUNIT), player.mo.y+P_ReturnThrustY(player.mo, player.drawangle, 12*FRACUNIT), player.mo.z + player.mo.height/2, MT_EXEKNIFE)
						knife.scale = player.mo.scale/4
						knife.target = player.mo
						if player.mo.eflags & MFE_VERTICALFLIP then
							knife.flags2 = $1|MF2_OBJECTFLIP
						end
						knife.angle = player.drawangle
						P_InstaThrust(knife, player.drawangle, 40*FRACUNIT)
						knife.momz = FixedMul(40*FRACUNIT, sin(player.aiming))
						return 
					end
					if not enemy return end
					if (enemy.valid)
					and (enemy.health)
					and ((enemy.flags & MF_ENEMY) or (enemy.flags & MF_BOSS))
						player.lockenemy = enemy
					end
				end
				player.knifephase = 1
			elseif (player.knifephase == 1)
				player.knifephase = 0
				S_StartSound(player.mo, sfx_knftrw)
				if not (player.lockenemy) return end
				if (player.knifecount == 0)
				and not player.powers[pw_super]
					return
				elseif not player.powers[pw_super]
				and (player.knifecount > 0)
					player.knifecount = $ - 1
				end
				if not (player.lockenemy) return end
				if not (player.lockenemy.dead)
					if (player.lockenemy.flags & MF_ENEMY)
						P_KillMobj(player.lockenemy, knife, player.mo)
					elseif (player.lockenemy.flags & MF_BOSS)
						P_DamageMobj(player.lockenemy, knife, player.mo)
						return
					end
					player.lockenemy.dead = true
				end
				player.lockenemy = nil
			else
				player.lockenemy = nil
			end
		end
		if (player.lockenemy)
			if (R_PointToDist2(player.mo.x, player.mo.y, player.lockenemy.x, player.lockenemy.y) >= 512*FRACUNIT)
				player.lockenemy = nil
			end
		end
		if not (player.cmd.buttons & BT_USE)
		and (player.knifeshoot == 1)
			player.knifeshoot = 0
		end
		if (player.cmd.buttons & BT_TOSSFLAG)
		and not G_RingSlingerGametype()
		and (player.powers[pw_carry] ~= CR_NIGHTSMODE)
		and (player.powers[pw_carry] ~= CR_NIGHTSFALL)
		and not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
			if (player.shop == false)
			and (player.powers[pw_carry] == CR_NONE)
			and (player.playerstate == PST_LIVE)
			and not (player.pflags & PF_FINISHED)
			and not (player.exiting)
			and (player.speed == 0)
			and (player.shoptimer == 0)
				S_ChangeMusic("exems"+tostring(P_RandomRange(1,4)), true, player, nil, 0, MUSICRATE, MUSICRATE)
				player.shop = true
				player.shopitem = 0
				player.shoptext = 0
			end
			if (player.shop == true)
			and (player.shoptimer >= TICRATE)
				S_ChangeMusic(mapheaderinfo[gamemap].musname, true, player, nil, 0, MUSICRATE, MUSICRATE)
				player.shop = false
				player.shopitem = 0
				player.shoptimer = TICRATE
			end
		end
		if (player.shop == true)
		and (player.shoptimer < TICRATE)
			if (cv_instashop.value)
			and (player.shoptimer < TICRATE-4)
				player.shoptimer = TICRATE-5
			end
			player.shoptimer = $ + 1
		elseif (player.shop == false)
		and (player.shoptimer > 0)
			if (cv_instashop.value)
			and (player.shoptimer > 4)
				player.shoptimer = 5
			end
			player.shoptimer = $ - 1
		end
		if (player.powers[pw_super])
			player.spindash = 1
			player.tailsdoll = 1
		end
		if (CV_FindVar("renderer").value == "Software")
			if (player.exehealth == 85)
			or (player.insane == true)
				P_FlashPal(player, 14, 1)
			elseif (player.exehealth < 85) and (player.exehealth >= 75)
				P_FlashPal(player, 13, 1)
			elseif (player.exehealth < 75) and (player.exehealth >= 65)
				P_FlashPal(player, 12, 1)
			end
		end
		if (player.shop == true)
			player.pflags = $1|PF_FULLSTASIS
			if (player.shoptimer == 35)
			and (player.shoptext < 54)
				player.shoptext = $ + 1
			end
			if (player.cmd.buttons & BT_JUMP)
			and (player.pb == 0)
				player.pb = 1
				if (player.shopitem == 0)
					if (player.souls > 1)
						player.souls = $ - 2
						player.knifecount = $ + 1
						S_StartSound(nil, sfx_s3kb0, player)
					else
						S_StartSound(nil, sfx_lose, player)
					end
				elseif (player.shopitem == 1)
					if (player.souls > 39)
					and (player.tailsdoll == 0)
						player.souls = $ - 40
						player.tailsdoll = 1
						S_StartSound(nil, sfx_s3kb0, player)
					else
						S_StartSound(nil, sfx_lose, player)
					end
				elseif (player.shopitem == 2)
					if (player.souls > 199)
					and (player.spindash ~= 1)
						player.souls = $ - 200
						player.spindash = 1
						S_StartSound(nil, sfx_s3kb0, player)
					else
						S_StartSound(nil, sfx_lose, player)
					end
				elseif (player.shopitem == 3)
					if (player.souls > 149)
					and (player.jumpthok ~= 1)
						player.souls = $ - 150
						player.jumpthok = 1
						S_StartSound(nil, sfx_s3kb0, player)
					else
						S_StartSound(nil, sfx_lose, player)
					end
				else
					if (player.souls > 299)
					and (player.radar ~= 1)
						player.souls = $ - 300
						player.radar = 1
						S_StartSound(nil, sfx_s3kb0, player)
					else
						S_StartSound(nil, sfx_lose, player)
					end
				end
			end
			player.actionspd = player.speed/FRACUNIT
			if not (player.cmd.buttons & BT_JUMP)
			and (player.pb == 1)
				player.pb = 0
			end
			if ((player.cmd.buttons & BT_WEAPONNEXT) or (player.cmd.buttons & BT_CUSTOM3))
			and (player.pr == 0)
				player.pr = 1
				if not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
					S_StartSound(nil, sfx_menu1, player)
				end
				if (player.shopitem == 4)
					player.shopitem = 0
				else
					player.shopitem = $ + 1
				end
			elseif ((player.cmd.buttons & BT_WEAPONPREV) or (player.cmd.buttons & BT_CUSTOM1))
			and (player.pl == 0)
				player.pl = 1
				if not (CBW_Battle) and not (gametype == GT_EXESURVIVAL)
					S_StartSound(nil, sfx_menu1, player)
				end
				if (player.shopitem == 0)
					player.shopitem = 4
				else
					player.shopitem = $ - 1
				end
			end
			if not (player.cmd.buttons & BT_WEAPONNEXT)
			and not (player.cmd.buttons & BT_CUSTOM3)
			and (player.pr == 1)
				player.pr = 0
			end
			if not (player.cmd.buttons & BT_WEAPONPREV)
			and not (player.cmd.buttons & BT_CUSTOM1)
			and (player.pl == 1)
				player.pl = 0
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if not (player.lockenemy) return end
	if (player.selected ~= 0)
		player.lockenemy = nil
	end
	if not (player.lockenemy) return end
	if (player.lockenemy.valid)
		P_SpawnLockOn(player, player.lockenemy, S_LOCKON1)
		player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, player.lockenemy.x, player.lockenemy.y)
	end
end)

addHook("MobjMoveCollide", function(pmo, spike)
	if (pmo.valid) 
	and (pmo.skin == "exetior") 
	and ((pmo.state == S_PLAY_EXERUN) or (pmo.state == S_PLAY_RUN) or (pmo.state == S_PLAY_ROLL))
	and (spike.valid) 
	and (spike.type == MT_SPIKE)
	and (pmo.z >= spike.z) and (pmo.z < spike.z+spike.height)
		P_KillMobj(spike, pmo, pmo)
	end
end, MT_PLAYER)
/*
hud.add(function(v, player)
	if player.mo and player.mo.skin ~= "exetior" return end
	if (player.strpost == nil) return end
	if (player.strnum == nil) return end
	if (player.str == nil) return end
	if (player.shop == true) return end
	if not (server.starpostnum) return end
	local str1 = "Starpost Teleport"
	local str2 = "Choose your location"
	v.drawString(160,200-player.strpost*3, str1, 0, "center")
	v.drawString(160,200-player.strpost*3+10, str2, 0, "thin-center")
	if not (player.starpostnum)
		if (player.strnum < server.starpostnum)
			v.drawString(160,200-player.strpost*3+20, player.strnum, V_GRAYMAP, "center")
		else
			v.drawString(160,200-player.strpost*3+20, player.strnum, 0, "center")
		end
		if (player.strnum-1 < server.starpostnum)
			if (player.strnum-1 < 0)
				v.drawString(160,200-player.strpost*3+20, server.starpostnum, V_GRAYMAP, "center")
			else
				v.drawString(160,200-player.strpost*3+20, player.strnum-1, V_GRAYMAP, "center")
			end
		else
			if (player.strnum-1 < 0)
				v.drawString(160,200-player.strpost*3+20, server.starpostnum, 0, "center")
			else
				v.drawString(160,200-player.strpost*3+20, player.strnum-1, 0, "center")
			end
		end
		if (player.strnum+1 < server.starpostnum)
			if (player.strnum+1 > server.starpostnum)
				v.drawString(160,200-player.strpost*3+20, "0", V_GRAYMAP, "center")
			else
				v.drawString(160,200-player.strpost*3+20, player.strnum+1, V_GRAYMAP, "center")
			end
		else
			if (player.strnum+1 > server.starpostnum)
				v.drawString(160,200-player.strpost*3+20, "0", 0, "center")
			else
				v.drawString(160,200-player.strpost*3+20, player.strnum+1, 0, "center")
			end
		end
	end
end, "game")*/

hud.add(function(v, player)
	if player.mo and player.mo.skin ~= "exetior" return end
	if (player.selected == nil) return end
	local t = ""
	local s = ""
		
	if (player.tailsdoll == 0)
	and not (player.powers[pw_super])
		t = "T"
	end
	if (player.spindash == 0)
	and not (player.powers[pw_super])
		s = "S"
	end
	if G_RingSlingerGametype() return end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) return end
	if (player.powers[pw_carry] == CR_NIGHTSFALL) return end
	if (CBW_Battle) return end
	if (gametype == GT_EXESURVIVAL) return end
	local knife = v.cachePatch("KNIFEHUD")
	local baar = v.cachePatch(t+s+"ITEM"+tostring(player.selected+1))
	local infinity = v.cachePatch("STCFN022")
	v.draw(320,42,baar,V_SNAPTORIGHT)
	if not (player.powers[pw_super])
		v.drawString(260,60,tostring(player.knifecount),V_SNAPTORIGHT)
	else
		v.draw(260,60,infinity,V_SNAPTORIGHT)
	end
	v.draw(260+string.len(player.knifecount)*10,60,knife,V_SNAPTORIGHT)
	if (player.shoptimer)
		local text = "What would you like to buy?"
		local y = 0+(player.shoptimer*(55/10))
		local flags = V_MONOSPACE|V_PERPLAYER
		
		local pic = v.cachePatch("BLACK")
		local pic2 = v.cachePatch("SHOP1")
		local pic3 = v.cachePatch("SHOP2")
		local item1 = v.cachePatch("KNIFE")
		local item2 = v.cachePatch("DOLL")
		local item3 = v.cachePatch("SPIN")
		local item4 = v.cachePatch("JUMP")
		local item5 = v.cachePatch("RADAR")
		v.draw(0,0,pic,V_SNAPTOLEFT|V_SNAPTOTOP|V_30TRANS)
		if (player.shoptimer == TICRATE)
			//lol secreeeet
			if (string.lower(mapheaderinfo[gamemap].lvlttl) == "tyrcity hub")
			or (string.lower(mapheaderinfo[gamemap].lvlttl) == "tyrcity halloween")
			or (string.lower(mapheaderinfo[gamemap].lvlttl) == "darkness")
			or (string.lower(mapheaderinfo[gamemap].lvlttl) == "tyrcity boss")
				pic3 = v.cachePatch("SHOP3")
			end
			v.draw(160,y+20,pic3)
			v.drawString(60,183,string.sub(text, 0, player.shoptext), V_CENTERNAMETAG)
			if (player.shopitem == 0)
				v.draw(160,y-30,item1)
				v.draw(220,y-30,item2)
				v.draw(100,y-30,item5)
				v.drawString(160,y-160,"Knife", flags, "center")
				v.drawString(160,y-150,"Costs 2 souls", flags|V_YELLOWMAP, "thin-center")
				v.drawString(160,y-140,"Gives you a knife that", flags, "thin-center")
				v.drawString(160,y-130,"you can throw at enemies", flags, "thin-center")
				v.drawString(160,y-120,"that instantly hits them, stackable.", flags, "thin-center")
			elseif (player.shopitem == 1)
				v.draw(160,y-30,item2)
				v.draw(220,y-30,item3)
				v.draw(100,y-30,item1)
				v.drawString(160,y-160,"Tails Doll", flags, "center")
				v.drawString(160,y-150,"Costs 40 souls", flags|V_YELLOWMAP, "thin-center")
				v.drawString(160,y-140,"Gives Exetior a tails doll plushie", flags, "thin-center")
				v.drawString(160,y-130,"that can automatically kill nearby", flags, "thin-center")
				v.drawString(160,y-120,"enemies. Lasts only one level", flags, "thin-center")
				if (player.tailsdoll == 1)
					v.drawString(160,y-110,"SOLD", flags|V_REDMAP, "center")
				end
			elseif (player.shopitem == 2)
				v.draw(160,y-30,item3)
				v.draw(220,y-30,item4)
				v.draw(100,y-30,item2)
				v.drawString(160,y-160,"Spindash", flags, "center")
				v.drawString(160,y-150,"Costs 200 souls", flags|V_YELLOWMAP, "thin-center")
				v.drawString(160,y-140,"Gives Exetior a spindash", flags, "thin-center")
				v.drawString(160,y-130,"and a spinning move", flags, "thin-center")
				v.drawString(160,y-120,"that you can uncurl from..", flags, "thin-center")
					if (player.spindash == 1)
					v.drawString(160,y-110,"SOLD", flags|V_REDMAP, "center")
				end
			elseif (player.shopitem == 3)
				v.draw(160,y-30,item4)
				v.draw(220,y-30,item5)
				v.draw(100,y-30,item3)
				v.drawString(160,y-160,"Jumpthok", flags, "center")
				v.drawString(160,y-150,"Costs 150 souls", flags|V_YELLOWMAP, "thin-center")
				v.drawString(160,y-140,"Upgrades the double jump", flags, "thin-center")
				v.drawString(160,y-130,"to a jumpthok that makes", flags, "thin-center")
				v.drawString(160,y-120,"using your ability easier.", flags, "thin-center")
					if (player.jumpthok == 1)
					v.drawString(160,y-110,"SOLD", flags|V_REDMAP, "center")
				end
			else
				v.draw(160,y-30,item5)
				v.draw(220,y-30,item1)
				v.draw(100,y-30,item4)
				v.drawString(160,y-160,"Radar", flags, "center")
				v.drawString(160,y-150,"Costs 300 souls", flags|V_YELLOWMAP, "thin-center")
				v.drawString(160,y-140,"Gives Sonic.EXE a permanent", flags, "thin-center")
				v.drawString(160,y-130,"radar to find enemies", flags, "thin-center")
				v.drawString(160,y-120,"easier.", flags, "thin-center")
					if (player.radar == 1)
					v.drawString(160,y-110,"SOLD", flags|V_REDMAP, "center")
				end
			end
		else
			v.draw(160,y,pic2)
		end
	end
end)

addHook("MapLoad", do
	for sector in sectors.iterate do
		if (string.lower(mapheaderinfo[gamemap].lvlttl) == "techno hill") 
		or ((string.lower(mapheaderinfo[gamemap].lvlttl) == "techno hill") and mapheaderinfo[gamemap].actnum == 1)
			sector.lightlevel = $ - 24
		end
	end
end)

hud.add(function(v, player)
	if not (player.exehealth) return end
	if G_RingSlingerGametype() return end
	if (player.powers[pw_carry] == CR_NIGHTSMODE) return end
	if (player.powers[pw_carry] == CR_NIGHTSFALL) return end
	if (cv_nostatic.value) return end
	if player.mo and player.mo.skin ~= "exetior" return end
	if (player.exehealth <= 85) and (player.exehealth >= 65)
	or (player.insane == true)
		v.drawStretched(0,0,2*FRACUNIT,2*FRACUNIT,v.cachePatch("STATIC"+tostring((leveltime%8)/2)),V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_SCALEPATCHMASK|V_90TRANS)
	end
end, "game")

-- k i r b y
if not (kirbyabilitytable)
	rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable["exetior"] = -5
kirbyabilitytable["why"] = -9