freeslot("MT_TDFOLLOW", "S_TDFOLLOW", "SPR_TDOL")

 mobjinfo[MT_TDFOLLOW] = {
	spawnstate = S_TDFOLLOW,
	deathstate = S_NULL,
	radius = 10*FRACUNIT,
	height = 20*FRACUNIT,
	speed = 60*FRACUNIT,
	flags = MF_NOGRAVITY
}

states[S_TDFOLLOW] = {SPR_TDOL, A, -1, nil, 0, 0, S_TDFOLLOW}

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "exetior")
		if (leveltime == 0)
			player.tailsdoll = 0
		end
		if (player.selected == 1)
		and (player.tailsdoll == 1)
			if not (player.tdolfollower)
			or not (player.tdolfollower.valid)
				player.tdolfollower = P_SpawnMobj(
					player.mo.x + P_ReturnThrustX(player.mo, player.drawangle + ANGLE_45, -20*FRACUNIT), 
					player.mo.y + P_ReturnThrustY(player.mo, player.drawangle + ANGLE_45, -20*FRACUNIT),
					player.mo.z + player.mo.height/2,
					MT_TDFOLLOW
				)
				player.tdolfollower.target = player.mo
				player.tdolfollower.color = ColorOpposite(player.mo.color)
			end
			if P_LookForEnemies(player, false)
			and (player.tdolfollower)
			and not (player.tdolfollower.tracer)
			and not (player.cmd.buttons & BT_USE)
				player.tdolfollower.tracer = P_LookForEnemies(player, false)
			end
		end
	end
end)

addHook("MobjThinker", function(doll)
	if not (doll.target)
		P_KillMobj(doll)
		return
	end
	if (doll.target.player.selected ~= 1)
	or (doll.target.player.tailsdoll ~= 1)
		doll.target.player.tdolfollower = nil
		P_KillMobj(doll)
		return
	end
	doll.color = ColorOpposite(doll.target.color)
	if doll.target.eflags & MFE_VERTICALFLIP
		doll.flags2 = $1|MF2_OBJECTFLIP
	end
	doll.angle = doll.target.player.drawangle
	doll.scale = doll.target.scale/2
	if (doll.tracer == nil)
		P_TeleportMove(
			doll, 
			doll.target.x + P_ReturnThrustX(doll.target, doll.target.player.drawangle + ANGLE_45, -20*FRACUNIT), 
			doll.target.y + P_ReturnThrustY(doll.target, doll.target.player.drawangle + ANGLE_45, -20*FRACUNIT),
			doll.target.z + doll.target.height/2
		)
	else
		if (doll.target.player.cmd.buttons & BT_USE)
			doll.tracer = nil
			doll.momx = 0
			doll.momy = 0
			doll.momz = 0
			return
		end
		if (doll.tracer.frame ~= E)
			P_HomingAttack(doll, doll.tracer)
		end
	end
end, MT_TDFOLLOW)

addHook("MobjMoveCollide", function(doll, target)
	if (doll.valid)
	and (target.valid)
	and (target == doll.tracer)
	and (doll.z > target.z) and (doll.z < target.z+target.height)
		P_DamageMobj(target, doll, doll.target)
		doll.tracer = nil
	end
end, MT_TDFOLLOW)